if(!dojo._hasResource["com.ibm.isclite.data.custom.eventsandwires.ItemFileWriteStore"]){ 
dojo._hasResource["com.ibm.isclite.data.custom.eventsandwires.ItemFileWriteStore"] = true;

dojo.provide("com.ibm.isclite.data.custom.eventsandwires.ItemFileWriteStore");

//extend dojo's tree functionality
dojo.require("dojo.data.ItemFileWriteStore");

//com.ibm.isclite.data.custom.eventsandwires.ItemFileWriteStore
dojo.declare(
    "com.ibm.isclite.data.custom.eventsandwires.ItemFileWriteStore",
	dojo.data.ItemFileWriteStore,
{
	setValue: function(/* item */ item, /* attribute-name-string */ attribute, /* almost anything */ value, /*boolean?*/ callOnSet){
		// summary: See dojo.data.api.Write.set()
		if (callOnSet == null) {
			callOnSet = true;
		}
		return this._setValueOrValues(item, attribute, value, callOnSet); // boolean
	},
	
	setValues: function(/* item */ item, /* attribute-name-string */ attribute, /* array */ values, /*boolean?*/ callOnSet){
		// summary: See dojo.data.api.Write.setValues()
		if (callOnSet == null) {
			callOnSet = true;
		}
		return this._setValueOrValues(item, attribute, values, callOnSet); // boolean
	},

   newItem: function(/* Object? */ keywordArgs, /* Object? */ parentInfo,/*boolean*/callOnNew){
      // summary: See dojo.data.api.Write.newItem()
      
      if(callOnNew == undefined){
       callOnNew = true;
      }
      this._assert(!this._saveInProgress);
    
      if (!this._loadFinished){
       // We need to do this here so that we'll be able to find out what
       // identifierAttribute was specified in the data file.
       this._forceLoad();
      }
    
      if(typeof keywordArgs != "object" && typeof keywordArgs != "undefined"){
       throw new Error("newItem() was passed something other than an object");
      }
      var newIdentity = null;
      var identifierAttribute = this._getIdentifierAttribute();
      if(identifierAttribute === Number){
       newIdentity = this._arrayOfAllItems.length;
      }else{
       newIdentity = keywordArgs[identifierAttribute];
       if (typeof newIdentity === "undefined"){
        throw new Error("newItem() was not passed an identity for the new item");
       }
       if (dojo.isArray(newIdentity)){
        throw new Error("newItem() was not passed an single-valued identity");
       }
      }
    
      // make sure this identity is not already in use by another item, if identifiers were 
      // defined in the file.  Otherwise it would be the item count, 
      // which should always be unique in this case.
      if(this._itemsByIdentity){
       this._assert(typeof this._itemsByIdentity[newIdentity] === "undefined");
      }
      this._assert(typeof this._pending._newItems[newIdentity] === "undefined");
      this._assert(typeof this._pending._deletedItems[newIdentity] === "undefined");
    
      var newItem = {};
      newItem[this._storeRefPropName] = this;  
      newItem[this._itemNumPropName] = this._arrayOfAllItems.length;
      if(this._itemsByIdentity){
       this._itemsByIdentity[newIdentity] = newItem;
      }
      this._arrayOfAllItems.push(newItem);
    
      //We need to construct some data for the onNew call too...
      var pInfo = null;
    
      // Now we need to check to see where we want to assign this thingm if any.
      if(parentInfo && parentInfo.parent && parentInfo.attribute){
       pInfo = {
        item: parentInfo.parent,
        attribute: parentInfo.attribute,
        oldValue: undefined
       };
    
       //See if it is multi-valued or not and handle appropriately
       //Generally, all attributes are multi-valued for this store
       //So, we only need to append if there are already values present.
       var values = this.getValues(parentInfo.parent, parentInfo.attribute);
       if(values && values.length > 0){
        var tempValues = values.slice(0, values.length);
        if(values.length === 1){
         pInfo.oldValue = values[0];
        }else{
         pInfo.oldValue = values.slice(0, values.length);
        }
        tempValues.push(newItem);
        this._setValueOrValues(parentInfo.parent, parentInfo.attribute, tempValues, false);
        pInfo.newValue = this.getValues(parentInfo.parent, parentInfo.attribute);
       }else{
        this._setValueOrValues(parentInfo.parent, parentInfo.attribute, newItem, false);
        pInfo.newValue = newItem;
       }
      }else{
       //Toplevel item, add to both top list as well as all list.
       newItem[this._rootItemPropName]=true;
       this._arrayOfTopLevelItems.push(newItem);
      }
    
      this._pending._newItems[newIdentity] = newItem;
    
      //Clone over the properties to the new item
      for(var key in keywordArgs){
       if(key === this._storeRefPropName || key === this._itemNumPropName){
        // Bummer, the user is trying to do something like
        // newItem({_S:"foo"}).  Unfortunately, our superclass,
        // ItemFileReadStore, is already using _S in each of our items
        // to hold private info.  To avoid a naming collision, we 
        // need to move all our private info to some other property 
        // of all the items/objects.  So, we need to iterate over all
        // the items and do something like: 
        //    item.__S = item._S;
        //    item._S = undefined;
        // But first we have to make sure the new "__S" variable is 
        // not in use, which means we have to iterate over all the 
        // items checking for that.
        throw new Error("encountered bug in ItemFileWriteStore.newItem");
       }
       var value = keywordArgs[key];
    
       if(!dojo.isArray(value) && dojo.isObject(value) && value!=null){
        value = this.newItem(value,undefined,false);
       }
    
       if(!dojo.isArray(value)){
        value = [value];
       }
    
    
       newItem[key] = value;
      }
    
      if(callOnNew){
       this.onNew(newItem, pInfo); // dojo.data.api.Notification call
      }
      return newItem; // item
 },
   
   //We added isPortlet flag because of optimisation when deleting a whole portlet
	deleteItem: function(/* item */ item, /*Boolean*/isPortlet){
		// summary: See dojo.data.api.Write.deleteItem()
		this._assert(!this._saveInProgress);
		this._assertIsItem(item);

		// remove this item from the _arrayOfAllItems, but leave a null value in place
		// of the item, so as not to change the length of the array, so that in newItem() 
		// we can still safely do: newIdentity = this._arrayOfAllItems.length;
		var indexInArrayOfAllItems = item[this._itemNumPropName];
		this._arrayOfAllItems[indexInArrayOfAllItems] = null;
		
		var identity = this.getIdentity(item);
		item[this._storeRefPropName] = null;
		if(this._itemsByIdentity){
			delete this._itemsByIdentity[identity];
		}
		this._pending._deletedItems[identity] = item;
		
		//Remove from the toplevel items, if necessary...
		if(item[this._rootItemPropName]){
			this._removeArrayElement(this._arrayOfTopLevelItems, item);
		}
		this.onDelete(item, isPortlet); // dojo.data.api.Notification call
		return true;
	}   

});//com.ibm.isclite.data.custom.eventsandwires.ItemFileWriteStore

}//has resource