// 5648-C83, 5648-C84 (C) COPYRIGHT International Business Machines Corp., 2007 
// All rights reserved * Licensed Materials - Property of IBM  

///////////////////////////////////////////////////////////////
//The UIElement model object
function UIElement(element) {
    this.element=element;
  }


UIElement.prototype.id=function() {
    var result="null";
    if (this.element.id) {
        result=this.element.id;

    }
    return(result);
};


UIElement.prototype.debug2=function(msg) {
    alert(this.className() + ".id==" + this.id() + "\n" + msg);
};


UIElement.prototype.associate=function(name, event, method){
    var action=UIElement.getElementsByName(this.element, name);
    for (var i = 0; i < action.length ; i++)
      {
      dojo.connect(action[i], event, this, method);
      }
};


UIElement.getElementsByName=function(element, name)
{
    return dojo.query( '*[name="' + name + '"]', element );
};

UIElement.getAncestorByName=function(element, name)
	{
    var result=null;
    try
    	{
	    while(result==null && element!=null)
    		{
	    	element=element.parentNode;
			if(element.getAttribute("name")==name)
    			{
    			result=element;
    			}    	
    		}
     	}
    catch(e)
    	{
        //wasn't a node
    	}
    return(result);
	};

UIElement.getAncestorByNodeName = function( element, name ) {
	if( element == null ) {
		return( null );
	}
	else if( element.nodeName.toLowerCase() == name.toLowerCase() ) {
		return( element );
	}
	else {
		return( UIElement.getAncestorByNodeName( element.parentNode, name ) );
	}
};


UIElement.getElementById=function(element, id)
{
    var result=null;
    try
    {
        if (element.id==id) {
            return(element);
        }
        if (element.hasChildNodes()) {
            var children = element.childNodes;
            for (var i = 0; i < children.length; i++) {
                result=UIElement.getElementById(children[i],id);
                if (result!=null) {
                    return(result);
                }
            }
        }
    }
    catch(e)
    {
        //no id
    }
    return(result);

}

UIElement.getElementsByNodeName=function(element, name)
{
    return dojo.query( name, element );
}


UIElement.ObfuscateNamesAndIds = function( element ) {
	if( !element.getAttribute ) {
		return;
	}

	var ename = element.getAttribute("name");

	if( Page.NAME != ename && Portlet.NAME != ename ) {
		if( element.id != null && element.id != "" ) {
			// TODO: This line introduces errors on IE, cause not yet known.  FIXME!!!!!!!!
			//element.id += "UIELEMENTOBFUSCATOR";
		}
	
		if( ename != null && ename != "" ) {
			element.setAttribute( "name", ename + "UIELEMENTOBFUSCATOR" );
		}
	}

	if( element.hasChildNodes() ) {
		var children = element.childNodes;
		for( var i = 0; i < children.length; i++ ) {
			UIElement.ObfuscateNamesAndIds( children[i] );
		}
	}
}
UIElement.DeObfuscateNamesAndIds = function( element ) {
	if( !element.getAttribute ) {
		return;
	}

	var ename = element.getAttribute("name");

	if( element.id != null && element.id != "" ) {
		var i = element.id.indexOf( "UIELEMENTOBFUSCATOR" );
		if( i >= 0 ) {
			element.id = element.id.substring( 0, i );
		}
	}

	if( ename != null && ename != "" ) {
		var i = ename.indexOf( "UIELEMENTOBFUSCATOR" );
		if( i >= 0 ) {
			element.setAttribute( "name", ename.substring( 0, i ) );
		}
	}

	if( element.hasChildNodes() ) {
		var children = element.childNodes;
		for( var i = 0; i < children.length; i++ ) {
		  UIElement.DeObfuscateNamesAndIds( children[i] );
		}
	}
}
//The UIElement model object
///////////////////////////////////////////////////////////////

function PortletLink(anchor, portlet) {
	this.origOnClick = anchor.onclick; // 187467 - keep the original onclick function and execute it before requesting the fragment collection.
	this.anchor=anchor;
	this.portlet=portlet;
//	function IscPrRefreshablePortlet(pageId, portletId,refreshInterval,refreshMode,showTimer){
//	this.prPortlet=new IscPrRefreshablePortlet(portlet.page.id, portlet.id,0,"none",false);
}

/*
PortletLink.prototype.onFormSubmit=function(evt) {
	var href=evt.target.action;
	href=PortletLink.actionMap(href);
	evt.currentTarget.action=href;
	var reqHeaders=new Array();
	reqHeaders["If-Modified-Since"]="Sat, 1 Jan 2000 00:00:00 GMT";
		
	var bindArgs = {
		headers: 	reqHeaders,
		mimetype:   "text/html",
		formNode:	this.anchor,
		method:		evt.currentTarget.method,
		load: 		dojo.lang.hitch(top.Frameset, "FragmentCollectionCallback")			
		};
	/ / DEBUG console.info(bindArgs);				
    dojo.io.bind(bindArgs);
    evt.preventDefault();
    evt.stopPropagation();	
    return(false);    
 	}
*/

PortletLink.prototype.callback=function(type, data, evt) {
	//DEBUG console.info("PortletLink.prototype.callback");
	top.Frameset.FragmentCollectionCallback(type, data, evt);
	}
 
PortletLink.prototype.onclick=function(evt){
	//DEBUG console.info( "PortletLink.prototype.onclick Entry" );

	//DEBUG console.info( "this.origOnClick: " + this.origOnClick );

	// 187467 - keep original onclick function and execute it before requesting the fragment collection.
	if( this.origOnClick && !this.origOnClick(evt) ) {
		//DEBUG console.info( "anchor's 'onsubmit' function returned false" );
		return;
	}
	SMUtils.RequestFragmentCollection( this.anchor.href );
	evt.preventDefault();
	evt.stopPropagation();
}

PortletLink.hookAnchors=function(element) {
    //var anchors=UIElement.getElementsByNodeName(portlet.element, "a");
	var anchors=UIElement.getElementsByNodeName(element, "a");
    for (var i = 0; i < anchors.length ; i++) {
		SMUtils.BindAnchor( anchors[i] );
	}
}

  
PortletLink.hookForms=function(element) {
	//var forms=UIElement.getElementsByNodeName(portlet.element, "form");
	var forms=UIElement.getElementsByNodeName(element, "form");
    for (var i = 0; i < forms.length ; i++) {
		SMUtils.BindForm( forms[i] );
	}
}


///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////
//The Portlet model object
function Portlet(page, element) {
	this.page=page;
	this.element=element;
	this.intervalTime=0;
	this.timeoutID=0;
	var pd=element.getAttribute("portletDataObject");
	eval("var pdo=" + pd);
	this.portletData=pdo;
	element.modelObject = this;
  
	//  PortletLink.hookLink(this, Portlet.MINIMIZE);
	//  PortletLink.hookLink(this, Portlet.RESTORE);
	//  PortletLink.hookLink(this, Portlet.MAXIMIZE);
	/*
	if( top.Frameset.UseSM ) {
		PortletLink.hookAnchors(this);  
		PortletLink.hookForms(this);
		}
	*/
	}

//Portlet.emptyTextNode = document.createTextNode("");

//These two staments MUST immediatly follow  function Portlet
Portlet.prototype=new UIElement();
Portlet.prototype.constructor=Portlet;
 
Portlet.prototype.className=function(){
	return("Portlet");
	};
 
Portlet.prototype.updateAction=function(){
    this.debug2("updateAction");
};


Portlet.prototype.speak=function() {
    return "Speak Portlet.id==" + this.id();
};


Portlet.prototype.moduleRef=function() {
	return(this.portletData.moduleRef);
};

Portlet.prototype.handleResponse=function(responseCode, data){
	if(responseCode==200){
	    var divElement=this.element.ownerDocument.createElement("div");    //BugBug this probably leaks memory. Fix later.
	    divElement.innerHTML=data;
		var pElements=UIElement.getElementsByName(divElement,Portlet.NAME);
		var pElement=pElements[0];
    	if (pElement!=null) {
	    	pElement.modelObject=new Portlet(this.page, pElement);
       		this.replacePortlet(pElement);
		}
	}
	else{
		alert(responseCode);
	}
}


Portlet.prototype.callback=function(data)
{
    var divElement=this.element.ownerDocument.createElement("div");    //BugBug this probably leaks memory. Fix later.
    divElement.innerHTML=data;
	var pElements=UIElement.getElementsByName(divElement,Portlet.NAME);
	var pElement=pElements[0];
    if (pElement!=null) {
	    pElement.modelObject=new Portlet(this.page, pElement);
       	this.replacePortlet(pElement);
	}
	else {
	//alert("pElement==null");
	}
};


Portlet.prototype.replacePortlet=function(newPortlet) {
	//DEBUG console.info( "Portlet.prototype.replacePortlet Entry" );
	var newPortletElement;
	var newPortletObject;
	//DEBUG console.info("Portlet.prototype.replacePortlet typeOf" );
	//DEBUG console.info("typeof(newPortlet)" + typeof(newPortlet) + " newPortlet.constructor==" + newPortlet.constructor);
	//DEBUG console.info("typeof(this)" + typeof(this) + " this.constructor==" + this.constructor);
	if(typeof(newPortlet)=="object" && newPortlet.constructor==this.constructor) {
		newPortletElement=newPortlet.element;
		newPortletObject=newPortet;
		//DEBUG console.info("Its a portlet");
		}
	else {
		//DEBUG console.info("Its an element");
		newPortletElement=newPortlet;
		if(newPortletElement.modelObject==undefined) {
			newPortletObject=new Portlet(this.page,newPortletElement);
			newPortletElement.modelObject=newPortletObject;
			}
		else {
			newPortletObject=newPortletElement.modelObject;
			}
		}
    var portletParent=this.element.parentNode;
	newPortlet.page=this.page;
    if (portletParent!=null) {
        var replaced = portletParent.replaceChild(newPortlet,this.element);
       	dojo._destroyElement(replaced);
		SMUtils.RunScripts( newPortlet );

		//205352 cell is not part of new fragment, so update its class explicitly
		//210469 let RunScripts handle this portletParent.parentNode.className = newPortlet.getAttribute( "cellClass" );
        customizer.setupPorltetWiresDragAndDrop( newPortlet.parentNode);
		var tempFunc = function() {
			PortletLink.hookAnchors(newPortlet);  
			PortletLink.hookForms(newPortlet);
			doFpFetch( portletParent );
			};
		//222217
		//setTimeout( tempFunc, 1 );
		dojo.addOnLoad( tempFunc );
    	}
    this.destroy();
	};


/*
Portlet.prototype.startRefresh=function() {
    if (this.intervalTime>0) {
        this.timeoutID=setTimeout(dojo.lang.hitch(this,this.refresh), this.intervalTime);
    }
  };
*/

Portlet.prototype.destroy=function() {
	};

/*
Portlet.prototype.hide=function() {
	// Using 'page-hide' for now, might want a separate 'portlet-hide' css entry
	if (this.element.className != "page-hide") {
		this.element.className = "page-hide";
		this.element.appendChild(this.emptyTextNode); //Force IE to use the new class
		}
	};

Portlet.prototype.show=function() {
	// Using 'page-show' for now, might want a separate 'portlet-show' css entry
	if( this.element.className != "page-show" ) {
		this.element.className="page-show";
		this.element.removeChild(this.emptyTextNode);
		}
	};
*/


//////////////////////////////////////////////////////////////
//Statics
Portlet.NAME="IscPortlet";
Portlet.MINIMIZE="IscMinimize";
Portlet.RESTORE="IscRestore";
Portlet.MAXIMIZE="IscMaximize";
Portlet.REMOVE="IscRemove";
Portlet.REFRESH="IscRefresh";
Portlet.EDIT="IscEdit";
Portlet.BACK="IscBack";



Portlet.getPortletElements=function(rootElement) {
    var portletList=UIElement.getElementsByName(rootElement,Portlet.NAME);
    return(portletList);
};

Portlet.findContainingPortlet=function(element) {
	var result=null;
	while(element!=null & element!=document && element.getAttribute("name")!=Portlet.NAME) {
		element=element.parentNode;
		}
	if (element!=null) {
		result=element.modelObject;
		}
	return(result);
};	

//The Portlet model object
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////
//The Page model object
function Page(element) {
	//DEBUG console.info("constructing Page");	
	if (element==document) {
		element=Page.getPageElement(element);
		}
	this.element=element;
	element.modelObject=this;
	//DEBUG console.info("Page getting the page data object");	
	var pd=element.getAttribute("pagedataobject");
	eval("var pdo=" + pd);
	this.pageData=pdo;  
  if (this.pageData)  {
	  this.pageData.pageShowingEditMode=false;
  }
	//DEBUG console.info("Page going to create Portlets");
	this.createPortlets();
	//DEBUG console.info("Page created Portlets");
   // this.emptyTextNode = document.createTextNode("");

	// Defect 186435 - use client javascript to handle maximized windows
	this.handleMaximizedPortlet()
	}
	
	
 //These two staments MUST immediatly follow  function Page
Page.prototype=new UIElement();
Page.prototype.constructor=Page;

 
////Temporary addition to avoid the problems with DUI.addPortlet 
Page.prototype.actionPortletID=function() {
    return(this.getAttribute("actionPortletID"));
	};


Page.prototype.getPortletByID=function(id){
	return(UIElement.getElementById(this.element,id));
	};

Page.prototype.getPageElement=function(){
	return(this.element);
};

Page.prototype.getAttribute=function(attrName) {
	 return(this.element.getAttribute(attrName));
	};

Page.prototype.isPixelPage=function() { // REMOVE THIS
	return ( this.pageData.units == 'px' );
};

Page.prototype.isNoSizePage=function() {
	return ( this.pageData.noSize == true );
};

Page.prototype.isStateMaintained=function() {
	return (this.pageData.stateMaintained=="true");  // FIXME - mixing strings and bools
	};

Page.prototype.isPageInEditMode = function() {
  if ( this.pageData ) return this.pageData.editMode; 
  else return false;
};

Page.prototype.setPageInEditMode = function(bool) {
	this.pageData.editMode=bool;
};

Page.prototype.isPageShowingEditMode = function() {
	return(this.pageData.pageShowingEditMode==true);
};

Page.prototype.setPageShowingEditMode = function(bool) {
	this.pageData.pageShowingEditMode=bool;
};

Page.prototype.getPageResizeAccess = function() {
	if ( this.pageData ) return this.pageData.resizeAccess; 
	else return false;
};


Page.prototype.id=function() {
	return(this.element.id);
	}


Page.prototype.uniqueName=Page.prototype.id;


Page.prototype.moduleRef=function() {
    var result=this.element.getAttribute("moduleRef");
    return(result);
	};


Page.prototype.uid=function() {
    var result=this.element.getAttribute("uid");
    return(result);
	};


Page.prototype.createPortlets=function() {
    var portletList=Portlet.getPortletElements(this.element);
    for (var i = 0; i < portletList.length ; i++) {
        portletList[i].modelObject=new Portlet(this, portletList[i]);
    	}
	};

Page.prototype.getMaximizedPortlet = function() {
	//DEBUG console.info( "Page.prototype.getMaximizedPortlet entry" );
	// Get all portlet divs on this page
	//var portletList = Portlet.getPortletElements( this.element );	//187125
	var portletList = UIElement.getElementsByName( this.element, "PortletFragment" );  //187125 get the divs instead of the tables.

	// For each portlet div...
    for( var i = 0; i < portletList.length; i++ ) {
		// Get all the images in the portlet
		var images = UIElement.getElementsByNodeName( portletList[i], "img" );
		var hasMinimize = false;
		var hasRestore = false;

		// For each image...
		for( var j = 0; j < images.length; j++ ) {
			if( images[j] && images[j].getAttribute && images[j].getAttribute( "src" ) != null ) {
				// If it's the restore image...
				if( images[j].getAttribute( "src" ).indexOf( "/ibm/console/ISCProxy/images/content/title_restore.gif" ) != -1 ) {
					hasRestore = true;
				}
				// If it's the minimize image...
				else if( images[j].getAttribute( "src" ).indexOf( "/ibm/console/ISCProxy/images/content/title_minimize.gif" ) != -1 ) {
					hasMinimize = true;
				}
			}
		}

		// If the portlet has restore and minimize buttons, then it must be maximized.  Return it.
		if( hasRestore && hasMinimize ) {
			//DEBUG console.info( "Found maximized portlet" );
			return( portletList[i] );
		}
	}

	// No maximized portlets, return null.
	return( null );
};

Page.prototype.handleMaximizedPortlet = function() {
	//DEBUG console.info( "Page.prototype.handleMaximizedPortlet Entry" );

	// Get any maximized portlet on the focus page
	var maxPortlet = this.getMaximizedPortlet();
	//DEBUG console.info( "maxPortlet: " + maxPortlet );

	// Get all portlet divs on this page
	//var portletList = Portlet.getPortletElements( this.element );	//187125
	var portletList = UIElement.getElementsByName( this.element, "PortletFragment" );  //187125 get the divs instead of the tables.
	//DEBUG console.info( "portletList.length: " + portletList.length );

	// For each portlet div...
	for( var i = 0; i < portletList.length; i++ ) {
		// 205352 Hide non maximized cells
		var cell = portletList[i].parentNode;
		if( maxPortlet != null ) {
			if( portletList[i].id == maxPortlet.id ) {
				//210469 portletList[i].className = "page-show wire-dnd-target-portlet";
				cell.style.width="100%";
				cell.style.height="100%";
				cell.style.visibility="";
				cell.style.display="";
        portletList[i].style.width="100%";
        portletList[i].style.height="100%";
			}
			else {
				//210469 portletList[i].className = "page-hide";
				cell.style.width="";
				cell.style.height="";
				cell.style.visibility="hidden";
				cell.style.display="none";
			}
		}
		else {
			//210469 portletList[i].className = "page-show wire-dnd-target-portlet";
			cell.style.width="";
			cell.style.height="";
			cell.style.display="";
			var portletElements = UIElement.getElementsByName( portletList[i], "IscPortlet" );
			var portletElement = portletElements[0];			
			if ((portletElement) && (portletElement.attributes['closeWindow']) && (portletElement.attributes['closeWindow'].nodeValue == "true")){
					cell.style.visibility="hidden";
					cell.style.display="none";
			}
			else{
			cell.style.visibility="visible";
      cell.style.opacity="1";
			cell.style.filter="alpha(opacity=100)";
			}
      if ( customizer ) { //JCHAN
        // this function will set this portlet as restored portlet if it was
        // maximized 
        customizer.setRestoredPortlet(portletList[i].id);
        //JCHAN
      }
		}
	}

	// Get all the sizing bars
	var sizeBars = UIElement.getElementsByName( this.element, "IscSizebar" );

	// If a portlet is maximized...
	if( maxPortlet != null ) {
		// Hide all the sizing bars images
		for( var i = 0; i < sizeBars.length; i++ ) {
			sizeBars[i].childNodes[0].style.width="0px";
			sizeBars[i].childNodes[0].style.height="0px";
		}
	}
	else {
		// Unhide all the sizing bars
		for( var i = 0; i < sizeBars.length; i++ ) {
			sizeBars[i].childNodes[0].style.width="";
			sizeBars[i].childNodes[0].style.height="";
		}
	}
};
  //this hides an applet on an SM page and retains its data
Page.prototype.hideApplet = function() {
    if( this.element.getAttribute("class") != "page-hide" ) {
        this.element.style.position="absolute";
        this.element.setAttribute("class","page-hide");
        this.element.className="page-hide"; //needed for IE
    }
};

Page.prototype.hide = function() {
    if(this.element.getAttribute("class") != "page-hide") {
        this.element.setAttribute("class","page-hide");
		this.element.className="page-hide"; //needed for IE
		this.element.style.position="absolute";	//214677
    }
};

Page.prototype.show=function() {
    this.element.setAttribute("class","page-show wire-dnd-target-portlet");
	this.element.className="page-show wire-dnd-target-portlet";   //needed for IE
    this.element.style.position="absolute";
	//Fix for 207048, it seems that in Firefox, with RTL text direction, the pages did not have scrollbars
	if(!dojo._isBodyLtr() && dojo.isFF)
	{
		this.element.style.overflow = "auto";
		this.element.style.height = "100%";
		this.element.style.width = "99%";	
	}
};
	
Page.prototype.remove=function() {
	// Get all portlets on the page...
	var portlets = UIElement.getElementsByName( this.element, "PortletFragment" );

	// For each portlet...
	for( var i = 0; i < portlets.length; i++ ) {
		// De-register the portlet from PR
		try {
			iscPrDeRegiterPortletForRefresh( portlets[i].id );
		} 
		catch( e ) {
			// No PR?
		}
	}
        
   	dojo._destroyElement(this.element);	
	};



Page.prototype.replace=function(newPage) {
	//DEBUG console.info("Page.prototype.replace");
	var newPageElement;
	var newPageObject;
	if(typeof(newPage)=="object" && newPage.constructor==this.constructor) {  //newPage is already a page object
		//DEBUG console.info("its a Page object");
		newPageElement=newPage.element;
		newPageObject=newPage;
		}
	else {  //newPage is a element
		//DEBUG console.info("its a Page element");
		newPageElement=newPage;
		if(newPageElement.modelObject==undefined) {
			
			newPageObject=new Page(newPageElement);
			newPageElement.modelObject=newPageObject;
			}
		else {
			newPageObject=newPageElement.modelObject;
			}
		}

	//doFpSave( this.element );
	newPageObject.hide();
    var pageParent=this.element.parentNode;
    if (pageParent!=null) {
    	//DEBUG console.info("about to call pageParent.replaceChild");
        var replaced = pageParent.replaceChild(newPageElement, this.element);
       	dojo._destroyElement(replaced);
		SMUtils.RunScripts( newPageElement );

		var tempFunc = function() {
			PortletLink.hookAnchors(newPageElement);  
			PortletLink.hookForms(newPageElement);
			doFpFetch( newPageElement );
			};
		//222217
		//setTimeout( tempFunc, 1 );
		dojo.addOnLoad( tempFunc );
		}
    //DEBUG console.info("Page.prototype.replace complete");
	};

Page.prototype.removeWindows=function(portletId) {
	/*
	// De-register the portlet from PR
	try {
		iscPrDeRegiterPortletForRefresh( portletId );	// FIXME
	} 
	catch( e ) {
		// No PR?
	}
	*/

	//DEBUG console.info("remove " + portletId);
	};

// Page.prototype.updatePortlets( portletElementArray ): Update the portlets on this page with the new fragments.
Page.prototype.updatePortlets = function( portletElementArray ) {
	//DEBUG console.info( "Page.prototype.updatePortlets Entry, " + portletElementArray.length + " portlets to update." );
	//DEBUG console.info( "This page: " + this.id() );
   
	var parentPage = null;

	// For each new portlet fragment...
	for( var i = 0; i < portletElementArray.length; i++ ) {
		if( portletElementArray[i].getAttributeNode( "pageid" ).value != this.id() ) {
			//DEBUG console.info( "portlet " + i + ": " + portletElementArray[i].id + " is on a different page, skipping." );
		}
		else {
			//DEBUG console.info( "portlet " + i + ": " + portletElementArray[i].id );
			// Get the existing PortletFragment div with the same ID
			var portletFragment = this.getPortletByID( portletElementArray[i].id );
            
			// If the div doesn't exist...
			if( portletFragment == null ) {
				// Portlet must have been added by DUI.addPortlet()
				//DEBUG console.info( "Need to insert portlet window " + portletElementArray[i].id );
				var existingWindows = UIElement.getElementsByName( this.element, "PortletFragment" );
				for( var j = 0; j < existingWindows.length; j++ ) {
					//DEBUG console.info( "Existing window: " + existingWindows[j].id );
				}
				//alert( "Missing code to add a new portlet to the page should now be executing" );
	
				// Get all portlet elements in the page
				var portletList = Portlet.getPortletElements( this.element );
				// Get the last portlet element
				var lastPortletElement = portletList[portletList.length-1];
				//DEBUG console.info( "lastPortletElement: " + lastPortletElement.id );
	
				// Get the table holding all the portlets
				//var container = lastPortletElement.parentNode.parentNode.parentNode.parentNode;
				var container = UIElement.getAncestorByNodeName( lastPortletElement, "tbody" );
				//DEBUG console.info( "top container: " + container );
	
	
				var portletContents = UIElement.getElementsByName( portletElementArray[i], "IscPortlet" );
				//DEBUG console.info( "portletContents: " + portletContents.length );
	
				// Create a new row in the table for the new portlet.
				var newTD = document.createElement( "td" );
				if( portletContents.length > 0 ) {
					//DEBUG console.info( "window is visible" );
					//210469 newTD.className = "isc-layout-window";
				}
				else {
					//DEBUG console.info( "window is hidden" );
					//210469 newTD.className = "isc-layout-window-hide";
				}

				var newTR = document.createElement( "tr" );
				//DEBUG console.info( "new TD & TR created" );
				newTR.appendChild( newTD );
				newTD.appendChild( portletElementArray[i] );
				//DEBUG console.info( "new portlet added to new TD" );
	
				// Create the Portlet object for the new portlet.  This will make it SM aware (fix links/forms etc)
				portletElementArray[i].modelObject = new Portlet( this, portletElementArray[i] );
				//DEBUG console.info( "new portlet model object created" );
	
				// Create a speparater row
				var newSepTR = document.createElement( "tr" );
				var newSepTD = document.createElement( "td" );
				newSepTD.className = "isc-layout-sizebar-horizontal";
				var newSepImg = document.createElement( "img" );
				newSepImg.setAttribute( "src", "/ibm/console/ISCProxy/images/content/isc_grabbies_horz.gif" );
	
				newSepTD.appendChild( newSepImg );
				newSepTR.appendChild( newSepTD );
	
				// Add new rows to table
				container.appendChild( newSepTR );
				container.appendChild( newTR );
				//DEBUG console.info( "new rows added to page" );
	
				// Run any scripts in the new portlet
				SMUtils.RunScripts( newTR );

        var newPortletPage = this;
				var tempFunc = function() {
					PortletLink.hookAnchors(newTR);  
					PortletLink.hookForms(newTR);
					doFpFetch( newTR );
					newPortletPage.createPortlets();
					};
				//222217
				//setTimeout( tempFunc, 1 );
				dojo.addOnLoad( tempFunc );
				//DEBUG console.info( "Scripts run" );
			}
			// If the portlet div exists...
			else {
				//DEBUG console.info( "Need to update portlet window " + portletElementArray[i].id );
				// Get the IscPortlet div it contains
				var portletElements = UIElement.getElementsByName( portletFragment, "IscPortlet" );
				var portletElement = portletElements[0];
				//DEBUG console.info( "portletElement: " + portletElement );

				// Get the IscPortlet div in the new fragment
				var newPortletFragment = portletElementArray[i];
				var newPortletElements = UIElement.getElementsByName( newPortletFragment, "IscPortlet" );
				var newPortletElement = newPortletElements[0];
			   //DEBUG console.info( "newPortletElement: " + newPortletElement );
	
				var portlet = null;
				if(portletElement) {

					// Get the portlet model
				    portlet = portletElement.modelObject;

                    if (!portlet){
                        portletElement.modelObject = new Portlet( this, portletElement );
                        portlet = portletElement.modelObject;
                    }

					if( newPortletElement !=null ) {
						// Replace the IscPortlet div with the new one
					    portlet.replacePortlet( newPortletElement );
					}
					else {
                        //DEBUG console.info( "removing the node..." );
						// Remove the IscPortlet div
						portletFragment.removeChild( portletElement );
	                    
						//DEBUG console.info( "Portlet removed" );

                        //DEBUG console.info( "Destroying portlet in window: " + portletElement.id );
                        dojo._destroyElement(portletFragment);

						// Destroy the old portlet
						portlet.destroy();
						portlet = null;
					}
				}
				else if( newPortletElement ) {
					//DEBUG console.info( "creating a new portlet..." );
					//Need to create a new portlet, since the window started off empty.
					portletFragment.appendChild( newPortletElement );
					//DEBUG console.info ("creating modelObject..." );
					newPortletElement.modelObject = new Portlet( this, newPortletElement );
					//DEBUG console.info( "geting modelObject..." );
					// Get the portlet model
					portlet = newPortletElement.modelObject;
				}
	
				if( portlet != null ) parentPage = portlet.page;
			}
		}
	}

	if( parentPage != null ) {
		var tempFunc = function() {
			doFpFetch( parentPage.element );
			};
		//222217
		//setTimeout( tempFunc, 1 );
		dojo.addOnLoad( tempFunc );

		parentPage.handleMaximizedPortlet();
	}

	//DEBUG console.info( "Page.prototype.updatePortlets Exiting." );
};
///////////////////////////////////////////////////////////////
//Statics
Page.NAME="IscPage";


Page.getPageElement=function(doc) {
    var page=null;
    var pageList=null;
//    alert("Page.getPageElement\n" + doc);
//    try{
    	if(doc==document)
    		doc=document.body;
//    	alert("doc" + doc);
//	    pageList=doc.getElementsByName(Page.NAME);
//	    alert("pageList.length==" + pageList.length);
//    	}
//    catch(e){
//    alert("Exception getting Page.NAME\n" + e);
//    }
//    if (pageList==null)
    pageList=UIElement.getElementsByName(doc, Page.NAME);
    if (pageList.length>0) {
        page=pageList[0];
    	}
    return(page);
	};


Page.newPage=function() {
    alert("Create a new blank page now");
	Page.clone("com.ibm.isclite.admin.PortletPicker.navigationElement.pagelayoutA","com.ibm.isclite.admin.PortletPicker");
};


Page.clone=function(pageID, moduleRef){
var url="/ibm/console/taskbar.do?newPage=" + pageID + ";" + moduleRef;
Page.cloneURL(url);
}


Page.cloneURL=function(url) {
		dojo.xhrGet({
			url     :url,  
			load    : dojo.hitch(Pages, Pages.callback),    //Need to use an object instance to make thread safe?
			mimetype: "text/html"});
		};

Page.prototype.getTables = function(){
	return this.element.getElementsByTagName('Table');
}

//The Page model object
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// Beggings of a trace facility
/*
function myDebugConsole(){
	}
	
myDebugConsole.trace=false;	

myDebugconsole.info=function(message) {
	if(	myDebugConsole.trace) {
		myDebugConsole.print("I:" + message);
		}
	}	

myDebugConsole.error=function(message) {
	if(	myDebugConsole.trace) {
		myDebugConsole.print("E:" + message);
		}
	}	
	
	
myDebugConsole.print=function(message) {	
	alert(message);  //come up w/ something better than alert for IE.
	}
*/
// Beggings of a trace facility	
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
	

//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// The pages object keeps up with all the open pages
function IscPages() {
}

IscPages.ISC_FRAGMENT_PAGES_ID="IscFragmentPages";
IscPages.ISC_FRAGMENT_PORTLETS_ID="IscFragmentPortlets";
IscPages.ISC_DETAIL_COMMANDS_ID="detailCommands";

IscPages.taskList=null;

IscPages.onLoad=function () {

/*	if(typeof console=="undefined") {
		console=myDebugConsole;
		}
*/		
	//DEBUG console.info("content.js IscPages.onLoad");
	IscPages.init();
   // var debugTest=IscPages.getAllPageElements();
	//for(var i=0;i<debugTest.length; i++) {
		//DEBUG console.info("Found page: " + debugTest[i].id);
	  //  }
	}


IscPages.init=function () {
	if (IscPages.currentPageId==null) {
		var pg=new Page(document);
		IscPages.currentPageId=pg.id();
		}
	IscPages.focus( IscPages.currentPageId );
	}


IscPages.addTask=function(page) {
	document.body.appendChild(page.element);
	var uid=page.uid();
	IscPages.taskList[uid]=page;
	SMUtils.RunScripts( page.element );

	var tempFunc = function() {
		PortletLink.hookAnchors(page.element);  
		PortletLink.hookForms(page.element);
		doFpFetch( page.element );
		};
	//222217
	//setTimeout( tempFunc, 1 );
	dojo.addOnLoad( tempFunc );
	}


IscPages.closeTask=function(page) {
	IscPages.taskList[page.uid()]=null;
	//remove the div
	}


IscPages.closeTaskById=function(id) {
	var page=IscPages.taskList[id];
    IscPages.closeTask(page);
	}


IscPages.selectTaskById=function(id) {
    //alert("selectTaskById(" + id + ")");
	var page=IscPages.taskList[id];
    IscPages.selectTask(page);
	}


IscPages.selectTask=function(page) {
	//doFpSave( IscPages.currentPage.element );
	IscPages.currentPage.hide();
    IscPages.currentPage=page;
	dojo.xhrGet({
        url     :"/ibm/console/taskbar.do",  
        content :{updateBreadCrumb: page.uid(), 
				  pageID: page.id(), 
                  moduleRef: page.moduleRef(),
                  TID: page.uid()},
        load    : dojo.hitch(IscPages, IscPages.nop),
		error	: dojo.hitch(IscPages, IscPages.nop),
        mimetype: "text/html"});
    page.show();
	}

IscPages.nop=function(type, data, evt) {
	//alert("load" + data);
	//ISCAggregator.reloadTaskbar();
	//doNothing
	}


IscPages.nop2=function(type, data, evt) {
	alert("error" + data);
	//doNothing
	}


IscPages.reloadTaskbar=function() {
	if ((parent.taskbar) &&(parent.taskbar.Task))
	    parent.taskbar.Task.reload();
	}


IscPages.Launch=function(link) {
	IscPages.LaunchURL(link.href);
	}


IscPages.LaunchPage=function(pageID, moduleRef) {
	var url="/ibm/console/navigation.do?pageID=" + pageID + "&moduleRef=" + moduleRef + "&ISC.TASKTYPE=2";
	IscPages.LaunchURL(url);
	}


IscPages.LaunchURL=function(url) { 
	dojo.xhrGet({
		url     :url,  
        load    : dojo.hitch(IscPages, IscPages.LaunchCallback),    //Need to use an object instance to make thread safe?
        mimetype: "text/html"});
	};


IscPages.LaunchCallback=function(type, data, evt) {
	IscPages.LoadCallback(type, data, evt);
    IscPages.selectTask(page);
	IscPages.reloadTaskbar();
	};


IscPages.LoadCallback=function(type, data, evt) {
    var html=document.createElement("html");
    html.innerHTML=data;
    var pgElem=Page.getPageElement(html);
    var page=new Page(pgElem);
    page.hide();
    IscPages.addTask(page);
	IscPages.reloadTaskbar();
};

IscPages.getAllPageElements=function() {
	var result=new Array();
	var children=document.body.childNodes;
	for(var i=0;i<children.length;i++) {
		if (children[i].nodeType==document.body.nodeType) {  //if this node is of type Node.ELEMENT_NODE
			try {
				var nameValue=children[i].getAttribute("name");
				if (nameValue==Page.NAME) {
					result[result.length]=children[i];
					}
				}
			catch(e) {
				}
			}
		}
	return(result);
	}
	
IscPages.getPageElementById=function(id) {	
	var result=null;
	var children=document.body.childNodes;
	for(var i=0;i<children.length && result==null;i++) {
		if (children[i].nodeType==document.body.nodeType) {  //if this node is of type Node.ELEMENT_NODE
			if(children[i].id==id) {
				result=children[i];
				}
			}
		}
	return(result);
	}
	
IscPages.getPageObjectById=function(id) {	
	var result=null;
	var pageElement=IscPages.getPageElementById(id);
	if(pageElement!=null) {
		//DEBUG console.info("IscPages.getPageObjectById  pageElement.modelObject"  + pageElement.modelObject);
		result=pageElement.modelObject;
		}
	return(result);
	}	
	
	
// IscPages.UpdatePortletFragments( htmlString ): Find the portlet fragments in the provided fragment collection html.  If any are found, update the DOM with them.
IscPages.UpdatePortletFragments = function( htmlString ) {
	//DEBUG console.info( "  IscPages.UpdatePortletFragments() Entry" );
	// Create a new div
	var tempDivElement = document.createElement("div");
      
	/* 187831 Start */
	/**
	 * On IE, when the new code is inserted into the DOM, all of the links become fully qualified.
	 * This 'corrupts' anchors like:
	 *      <a href="#" onclick="function()"></a>
	 * because the href is replaced with the fully qualified href of the current page.
	 * With State Maintained operation, the 'current page' is the last page loaded directly (rather than through DOM updates).
	 * This is usually the Welcome page href (https://host:port/ibm/console/navigation.do?wpageid=.....), with the result that
	 * clicking on a link like the one described above calls the onclick function then loads the welcome page, which is
	 * definitely NOT the desired behavior.
	 * This code section finds href values starting with # before they are added to the DOM and qualified.  The href values
	 * are replaced with "javascript:void(0)" for now.
	 * TODO: Instead replace the HREF with code to scroll the window to the named anchor if specified.
	 **/
	var newHtmlString = null;
	newHtmlString = htmlString.replace( new RegExp( "href=\"#", "gi" ), "href=\"javascript:void(0)\" orighref=\"#" );
	newHtmlString = newHtmlString.replace( new RegExp( "href=\'#", "gi" ), "href=\"javascript:void(0)\" orighref=\'#" );

	// Put the fragment collection HTML into the new div
	tempDivElement.innerHTML = newHtmlString;
    
	/* 187831 End */

	// Get the IscFragmentPortlets div in the new HTML
	var portletFragmentsDiv = UIElement.getElementById(tempDivElement, IscPages.ISC_FRAGMENT_PORTLETS_ID);  

	// If the IscFragmentPortlets div is found...
	if( portletFragmentsDiv != null ) {
		// Get each PortletFragment div in the IscFragmentPortlets div
		var portletFragments = UIElement.getElementsByName( portletFragmentsDiv, "PortletFragment" );  

		//DEBUG console.info( "  IscPages.UpdatePortletFragments portletFragments: " + portletFragments.length );

		// If there's a IscFragmentPortlets div, then it should always contain at least one PortletFragment, but check to make sure.
		if( portletFragments.length > 0 ) {
			// Note: Portlet fragments are always all on the same page
			/**
			 * Above statement is false.  Consider this example:
			 * 1) Page1 with PortletX
			 * 2) PortletX submits a portlet action request
			 * 3) Request uses DUI to launch a new copy of Page2 (which contains PortletY)
			 * 4) Page2 has context info defined in PAA.
			 * 5) Needed fragments: PortletX, Page2, PortletY (with context)
			 **/
			var pPageId = null;
			for( var i = 0; i < portletFragments.length; i++ ) {
				if( pPageId != portletFragments[i].getAttribute( "pageid" ) ) {
					pPageId = portletFragments[i].getAttribute( "pageid" );

					// Get the page containing the portlets
					var pageIdToUpdate = portletFragments[i].getAttribute( "pageid" );
					//DEBUG console.info( "  IscPages.UpdatePortletFragments Page containing portlet fragments: " + pageIdToUpdate );
					var pageToUpdate = IscPages.getPageObjectById( pageIdToUpdate );
					// If the page is not in the DOM...
				   if( pageToUpdate == null ) {
						//DEBUG console.info( "  IscPages.UpdatePortletFragments Page containing these portlet fragments is not currently in the DOM, retrieving..." );
						// Make a new request to the server to get the missing page.
						/*
						var reqHeaders = new Array();
						reqHeaders["If-Modified-Since"] = "Sat, 1 Jan 2000 00:00:00 GMT";
						dojo.io.bind( {
							headers:	reqHeaders,
							url:		"/ibm/console/pgfa.do?pageid=" + pageIdToUpdate,
							load:		top.Frameset.FragmentCollectionCallback, 
							mimetype:	"text/html"
						} );
						*/
						SMUtils.RequestFragmentCollection( "/ibm/console/pgfa.do?pageid=" + pageIdToUpdate );
					}
					// If the page is in the DOM...
				    else {
                        //DEBUG console.info( "  IscPages.UpdatePortletFragments pageToUpdate exists in the DOM, updating..." );
						// Update the portlets on the page
                        pageToUpdate.updatePortlets( portletFragments);
					}
				}
			}
		}
	}

	// Remove the new div
	dojo._destroyElement(tempDivElement);	

	//DEBUG console.info( "  IscPages.UpdatePortletFragments() Exit" );
}
	
IscPages.updatePage=function(updatedPageElement){
	//DEBUG console.info( "    IscPages.updatePage( " + updatedPageElement.id + " ) Entry" );

	var page = IscPages.getPageObjectById(updatedPageElement.id);

	if( page == null ) {
	   // console.info( "    IscPages.updatePage Page " + updatedPageElement.id + " not found in IscPages" );
		if( updatedPageElement.modelObject == undefined ) {
			//DEBUG console.info("updatedPageElement.modelObject==undefined");
			var pg = new Page( updatedPageElement );  //create the javascript object for this page
		}
		//DEBUG console.info("about to hide the newly updated Page");	
		updatedPageElement.modelObject.hide();
		//DEBUG console.info("Hid the newly updated Page");	
		document.body.appendChild(updatedPageElement);
		SMUtils.RunScripts( updatedPageElement );

		var tempFunc = function() {
			PortletLink.hookAnchors(updatedPageElement);  
			PortletLink.hookForms(updatedPageElement);
			doFpFetch( updatedPageElement );
		};
		//222217
		//setTimeout( tempFunc, 1 );
		dojo.addOnLoad( tempFunc );

		//DEBUG console.info( "    IscPages.updatePage New page " + updatedPageElement.id + " added to IscPages" );
	}
	else {
		//DEBUG console.info( "    IscPages.updatePage Existing page " + updatedPageElement.id + " found in IscPages" );
		page.replace(updatedPageElement);
		//DEBUG console.info( "    IscPages.updatePage Existing page " + updatedPageElement.id + " updated." );
	}
	//DEBUG console.info( "    IscPages.updatePage() Exit" );
}


IscPages.UpdatePageFragments = function( htmlString ) {
	//DEBUG console.info( "  IscPages.UpdatePageFragments() Entry" );

	// Create a new div
	var tempDivElement = document.createElement( "div" );

	/* 187831 Start */
	/**
	 * On IE, when the new code is inserted into the DOM, all of the links become fully qualified.
	 * This 'corrupts' anchors like:
	 *      <a href="#" onclick="function()"></a>
	 * because the href is replaced with the fully qualified href of the current page.
	 * With State Maintained operation, the 'current page' is the last page loaded directly (rather than through DOM updates).
	 * This is usually the Welcome page href (https://host:port/ibm/console/navigation.do?wpageid=.....), with the result that
	 * clicking on a link like the one described above calls the onclick function then loads the welcome page, which is
	 * definitely NOT the desired behavior.
	 * This code section finds href values starting with # before they are added to the DOM and qualified.  The href values
	 * are replaced with "javascript:void(0)" for now.
	 * TODO: Instead replace the HREF with code to scroll the window to the named anchor if specified.
	 **/
	var newHtmlString = null;
	newHtmlString = htmlString.replace( new RegExp( "href=\"#", "gi" ), "href=\"javascript:void(0)\" orighref=\"#" );
	newHtmlString = newHtmlString.replace( new RegExp( "href=\'#", "gi" ), "href=\"javascript:void(0)\" orighref=\'#" );

	// Put the fragment collection HTML into the new div
	tempDivElement.innerHTML = newHtmlString;
	/* 187831 End */

	// Get the IscFragmentPages div in the new HTML
	var pageFragmentsDiv = UIElement.getElementById( tempDivElement, IscPages.ISC_FRAGMENT_PAGES_ID );  

	// If the IscFragmentPages div is found...
	if( pageFragmentsDiv != null ) {
		// Get each IscPage div in the IscFragmentPages div
		var pageFragments = UIElement.getElementsByName( tempDivElement, Page.NAME );  

		//DEBUG console.info( "  IscPages.UpdatePageFragments() Updating " + pageFragments.length + " page fragments..." );

		// For each page fragment...
		for( var i = 0; i < pageFragments.length; i++ ) {
			//DEBUG console.info( "Found pages  for " + pageFragments[i].id );
			// Update the page in the DOM
			IscPages.updatePage( pageFragments[i] );
		}
	}

	//DEBUG console.info( "  IscPages.UpdatePageFragments() Exit" );
}	

IscPages.currentPageId=null;

// IscPages.focus( focusPage ): Show the specified focusPage
IscPages.focus = function( focusPage ) {
	//DEBUG console.info( "    IscPages.focus(" + focusPage + ") Entry" );

	//216519
	if( focusPage != null && focusPage.indexOf("navigatorCmd.do") != -1 ) {
		// Show the non SM detail frame and hide the SM detail frame
		top.Frameset.PageLoad( false );
	}
	else {
		// Get the page to focus to
		var fp = IscPages.getPageObjectById( focusPage );
	
		// If the page to focus to is not currently in the DOM...
		if( fp == null ) {
			//DEBUG console.info( "    IscPages.focus Focus page not found, executing pgfa.do..." );
			// Make a new request to the server to get the missing page.
			SMUtils.RequestFragmentCollection( "/ibm/console/pgfa.do?pageid=" + focusPage );
		}
		// If the page to focus is already in the DOM...
		else {
			// If there is no current page...
			//if( IscPages.currentPageId == null ) {
				// Get all the pages in the DOM
				var allPages = IscPages.getAllPageElements();
	
				// For each page...
				for(var i = 0; i < allPages.length; i++ ) {
					// If it's not the focus page...
					if( fp.id() != allPages[i].id ) {
						// If the page is not SM...
						if( !allPages[i].modelObject.isStateMaintained() ) {
							// Remove the page from the DOM
							allPages[i].modelObject.remove();
						}
						// If it's SM...
						else {
							// Hide the page
							var innerHTML = allPages[i].innerHTML;
							//check for SM pages that display applets and hide them differently
							if (innerHTML.indexOf("\<object") != -1 ||  innerHTML.indexOf("\<applet") != -1 ){
								allPages[i].modelObject.hideApplet();
						   }
							else{
								allPages[i].modelObject.hide();
							}
						}
					}
					else {
						allPages[i].modelObject.hide();
					}
				}
			/*
			}
			// If the current page is not the new focus page...
			else if (fp.id()!=IscPages.currentPageId) {
				// Get the current page
				var curPageObj = IscPages.getPageObjectById( IscPages.currentPageId );
	
				// Hide the page
				curPageObj.hide();
	
				// If the page is not SM...
				if( !curPageObj.isStateMaintained() ) {
					// Remove the page from the DOM
					curPageObj.remove();
				}
			}
			// If the current page is the focus page...
			else {
				// Do (almost) nothing, the focus page just needs to be made visible again
			}
			*/
	
			 // Unhide the focus page
			fp.show();
	
			// Set the current page
			IscPages.currentPageId = fp.id();
	
      var maximizedPortlet = fp.getMaximizedPortlet();
      if (maximizedPortlet) {
        this.enterMaximizedMode(maximizedPortlet, fp.getPageElement());
      } else {
			  // Setup edit mode
			  if (fp.isPageInEditMode() && !fp.isPageShowingEditMode()) {
				  if ( customizer && customizer.enterCustomizeMode ) {
					  customizer.enterCustomizeMode( fp.getPageElement() );
				  }
			  } else if ( fp.getPageResizeAccess() && ! fp.isNoSizePage() ) { // 4340
				  // or personal resize mode if permitted and it's not a noSize page
				  if ( customizer && customizer.enterResizeMode ) {
					  customizer.enterResizeMode( fp.getPageElement() );
				  }
			  } else if ( ! fp.isNoSizePage() ) {
				  // just initialize relative sizing for sizes with no sizers
				  customizer.makePageRelative( fp.getPageElement() ); // WORK
			  } else if ( fp.getPageResizeAccess()) {
				  if ( customizer && customizer.enterResizeMode ) {
					  customizer.enterResizeMode( fp.getPageElement() );
				  }
			  }
        if ( customizer.restoredPortlet && customizer.restoredPortlet.pageId == fp.getPageElement().id ) {
	        // send broadcast portletResize event to all subscribed portlets on the current page after portlet is restored
	        var eventObj = { "name": "http://ibm.com/isclite#portletResize" };
	        EventBroker.sendFrameworkEvent( eventObj, IscPages.currentPageId );
        }
        // Reset the restoredPortlet var
        customizer.restoredPortlet = null;
      }
		}
	
		// Load the page (this will show the SM detail frame and hide the non SM detail frame
		top.Frameset.PageLoad( true );
	}

	//DEBUG console.info( "    IscPages.focus Exit" );
}

// Enter Maximized Mode...hide all portlets and set maximized portlet
// width and height to 100%. Send resize framework event
IscPages.enterMaximizedMode=function(maximizedPortletObj, pageDiv) {
	var portletList = UIElement.getElementsByName( pageDiv, "PortletFragment" );  //187125 get the divs instead of the tables.
  for( var i = 0; i < portletList.length; i++ ) {
    if( portletList[i].id != maximizedPortletObj.id ) {
      // hide this portlet
      portletList[i].parentNode.style.display = "none";
      portletList[i].parentNode.style.visibility = "hidden";
      portletList[i].parentNode.style.filter = "alpha(opacity=0)";
      maximizedPortletObj.style.width = "100%";
      maximizedPortletObj.style.height = "100%";
      maximizedPortletObj.parentNode.style.width = "100%";
      maximizedPortletObj.parentNode.style.height = "100%";
    }
  }
  // find and hide sizer bars (this works for page sizers as well)
  var layoutRoot = dojo.query( "table.isc-layout-root-table, table.isc-layout-stretchy-root-table", pageDiv )[0];
	if ( typeof layoutRoot == 'undefined' || !layoutRoot ) {
	  console.error( "error: layout root not found" );
	  return;
  }
	dojo.query( 'td[class^="isc-layout-sizebar-"]', layoutRoot ).forEach(
	  function( i ) {
		  dojo.style( i, 'visibility', 'hidden' );
	  }
	);

  // tell customizer which portlet is maximized
  var maxPortlet = { pageId: pageDiv.id, portletId: maximizedPortletObj.id };
  customizer.addMaximizedPortlet(maxPortlet);
  // make the page relative because we need the maximized portlet to be 100%
  customizer.makePageRelative( pageDiv ); 

	// send broadcast portletResize event to all subscribed portlets on the current page
	var eventObj = { "name": "http://ibm.com/isclite#portletResize" };
	EventBroker.sendFrameworkEvent( eventObj, IscPages.currentPageId );
}

IscPages.remove=function(removePageId) {
	var rp=IscPages.getPageObjectById(removePageId);
	rp.remove();
	}

IscPages.removeWindows=function(pageId) {
	var fp=IscPages.getPageObjectById(pageId);
	fp.removeWindows(pageId);  //BugBug pass the window ids up
	}


IscPages.ExecuteDetailCommands=function(htmlString) {
	//DEBUG console.info( "  IscPages.ExecuteDetailCommands() Entry" );

	var tempDivElement=document.createElement("div");
	tempDivElement.innerHTML=htmlString;
	var commandsDiv=UIElement.getElementById(tempDivElement, IscPages.ISC_DETAIL_COMMANDS_ID); 
	var children=commandsDiv.childNodes;

	//DEBUG console.info( "  IscPages.ExecuteDetailCommands found " + children.length + " commands");

	for(var i=0;i<children.length;i++) {
		if (children[i].nodeType==document.body.nodeType) {  //if this node is of type Node.ELEMENT_NODE
			try {
				var nameValue=children[i].getAttribute("name");
				if (nameValue=="IscPageToFocus") {
					var currentPage=children[i].id;
					//DEBUG console.info( "  IscPages.ExecuteDetailCommands Focus to " + children[i].id );
					var pg=IscPages.getPageObjectById(currentPage);
					IscPages.focus(currentPage);
				}
				else if (nameValue=="IscPagesToRemove") {
					IscPages.remove(children[i].id);					
				}
				else if (nameValue=="IscWindowsToRemove") {
					IscPages.removeWindows(children[i].id);	  //This path needs help
                    }
				else if (nameValue=="IscUrlsToLaunch") {
					var urlsToLaunch = UIElement.getElementsByNodeName( children[i], "div" );
					for( var j = 0; j < urlsToLaunch.length; j++ ) {
						var nextUrl = urlsToLaunch[j].getAttribute( "name" );
						window.open( nextUrl, "_blank", 'resizable=yes,scrollbars=yes,menubar=yes,toolbar=yes,status=yes,location=yes,directories=yes,width=800,height=600,top=40,left=40' );
					}
				}
			}
			catch(e) {
			}
		}
	}

	//DEBUG console.info( "  IscPages.ExecuteDetailCommands() Exit" );
}
	
	

function UpdatePageFragments(htmlString) {
	//DEBUG console.info( "UpdatePageFragments() Entry" );

	if( !top.Frameset.UseSM ) {
		alert( "UpdatePageFragments: Something tried to use a SM function, even though SM operation is disabled!" );
		return;
	}

	IscPages.UpdatePageFragments(htmlString);

	//DEBUG console.info( "UpdatePageFragments() Exit" );
	}
	
function UpdatePortletFragments(htmlString) {
	if( !top.Frameset.UseSM ) {
		alert( "UpdatePortletFragments Something tried to use a SM function, even though SM operation is disabled!" );
		return;
	}

	IscPages.UpdatePortletFragments(htmlString);
	}	

function ExecuteDetailCommands(htmlString) {
	if( !top.Frameset.UseSM ) {
		alert( "ExecuteDetailCommands Something tried to use a SM function, even though SM operation is disabled!" );
		return;
	}

	IscPages.ExecuteDetailCommands(htmlString);

	// 186837: Force re-render on IE because IE goes into 'invisible mode' sometimes. Twiddling with the window size or toggling the nav pane fixes the rendering problem, so we do it here in code.
 /*	if( dojo.isIE ) {
		var tempFunc = function() {
			var togImg = parent.parent.header.document.getElementById( "NavTreeToggleImage" );
			togImg.click();
			togImg.click();
			};
		setTimeout( tempFunc, 1 );
		}
    */
	}	

function doFpSave( pageElem ) {
	//DEBUG console.info( "doFpSave() entry" );
	//DEBUG console.info( "about to fpSave() pageElem: " + pageElem + "..." );
	//var fpElem = UIElement.getElementsByName( pageElem, "IscPortlet" )[0];
	var fpElem = pageElem;
	//DEBUG console.info( "fpElem: " + fpElem + ": " + fpElem.nodeName + " " + fpElem.id );
	//fpSave( fpElem );
	try {
		//DO NOT SET fpCurrentPageId because will try to form persist pages with formPersist="false"
		//fpCurrentPageId = fpElem.id;
		fpSave( null, fpElem );
		//DEBUG console.info( "fpSave worked!" );
	}
	catch( e ) {
		//DEBUG console.info( "no fpSave" );
	}
}


function doFpFetch( pageElem ) {
	//DEBUG console.info( "doFpFetch() entry" );
	//DEBUG console.info( "about to fpFetch() pageElem: " + pageElem + "..." );
	//var fpElem = UIElement.getElementsByName( pageElem, "IscPortlet" )[0];
	var fpElem = pageElem;
	//DEBUG console.info( "fpElem: " + fpElem + ": " + fpElem.nodeName + " " + fpElem.id );
	try {
		//DO NOT SET fpCurrentPageId because will try to form persist pages with formPersist="false"
		//fpCurrentPageId = fpElem.id;
		fpFetch( null, fpElem );
		//DEBUG console.info( "fpFetch worked!" );
	} catch( e ) {
		//DEBUG console.info( "Error: " + e.message );
	}
}

var initTempFunc = function() {
	PortletLink.hookAnchors( document.body );  
	PortletLink.hookForms( document.body );
	overrideTimerHandling();
};
function overrideTimerHandling() {
	var defaultSetTimeoutFunction=window.setTimeout;
	var defaultClearTimeoutFunction=window.clearTimeout;
	var defaultSetIntervalFunction=window.setInterval;
	var defaultClearIntervalFunction=window.clearInterval;
	IscPages.tickingTimers=new Array();
	IscPages.tickingIntervals=new Array();
	window.setTimeout=function(code, interval){ 
			var result=defaultSetTimeoutFunction(code,interval);
			IscPages.tickingTimers.push(result);
			return(result);
			}
			
	window.clearTimeout=function(timeoutID) {
			defaultClearTimeoutFunction(timeoutID);
			for(var i=0;i<IscPages.tickingTimers.length;i++) {
				if(IscPages.tickingTimers[i]==timeoutID) {
					IscPages.tickingTimers.splice(i,1);
					return;
				}
			}
		}
		
	window.setInterval=function(code, delay){ 
			var result=defaultSetIntervalFunction(code,delay);
			IscPages.tickingIntervals.push(result);
			return(result);
			}
			
	window.clearInterval=function(intervalID) {
			defaultClearIntervalFunction(intervalID);
			for(var i=0;i<IscPages.tickingIntervals.length;i++) {
				if(IscPages.tickingIntervals[i]==intervalID) {
					IscPages.tickingIntervals.splice(i,1);
					return;
				}
			}
		}
	}

function clearAllTimers() {
	var timerID=IscPages.tickingTimers.pop();
	while(timerID!=undefined) {
		window.clearTimeout(timerID);
		timerID=IscPages.tickingTimers.pop();
		}
	timerID=IscPages.tickingIntervals.pop();
	while(timerID!=undefined) {
		window.clearTimeout(timerID);
		timerID=IscPages.tickingIntervals.pop();
		}
	}

dojo.addOnLoad(function(){
	initTempFunc();
});

