/*
 * Component Name: WAS.isc.isclite.cp
 * 
 * Licensed Materials - Property of IBM
 * 5724-I63, 5724-H88, 5655-N02, 5733-W70 
 * Copyright IBM Corp. 2006, 2007 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 * 
 */
 
//Form persistence global variables
var fpEnabled                     = true;

var fpIsCurrentFormSubmited       = false;                                            //holds is form sibmited - defect 196787 Input field should be empty while create credential store.
var fpCurrentFormSubmitedName     = '';                                               //holds form name if sibmited - defect 196787 Input field should be empty while create credential store.
var fpSubmitFormName              = '';                                               //holds the sibmiting form name
var fpFocusedElementName          = '';                                               //holds the name last focused element 
var fpFocusedElementFormName      = '';
var fpCurrentPageId               = '';                                               //holds the current page id
// 185366 replace fpXmlHttpRequest with pXHR    var fpXmlHttpRequest              = false;                                            //the Ajax request used by Form persistence mechanism
var fpUrl                         = '/ibm/console/fpa.do';                            // Form Persistence action url
var fpHttpMethod                  = 'POST';                                           // Ajax request type
var fpSkipPersistenceOnUnload     = false;                                            // Whether to skip the persistence on unload - when the user close the current page from the task bar

var fpSerializableElementTypes 	  = ["text","checkbox","hidden","radio","textarea","select-one","select-multiple"]; 

var fpInFieldDelimiter            = "#vd#";                                           // name value delimiter
var fpFieldDelimiter              = "#ed#";                                           // field delimiter
var fpFormDelimiter               = "#fd#";                                           // form delimiter
var fpCursorDelimiter             = "#cd#";                                           // cursor delimiter 
var fpSubmitFormDelimiter         = "#sd#";

var fpInFieldDelimiterEscaped     = "#\\vd#";
var fpFieldDelimiterEscaped       = "#\\ed#"; 
var fpFormDelimiterEscaped        = "#\\fd#";   
var fpCursorDelimiterEscaped      = "#\\cd#"; 
var fpSubmitFormDelimiterEscaped  = "#\\sd#";

var fpPortletIdPrefix			  = "iscPortlet_";
var fpPortletIdDelimiter		  = ";";
var fpPostFetchTryCount 		  = 0;

//End of Form persistence global variables



// escape fp delimiters
function fpEscape(str){

    var theString = str;
    theString= fpReplaceAllSmart(theString,"\\","\\\\");
    
    theString=fpReplaceAll(theString,fpInFieldDelimiter,fpInFieldDelimiterEscaped);
    theString=fpReplaceAll(theString,fpFieldDelimiter,fpFieldDelimiterEscaped);
    theString=fpReplaceAll(theString,fpFormDelimiter,fpFormDelimiterEscaped);
    theString=fpReplaceAll(theString,fpCursorDelimiter,fpCursorDelimiterEscaped);
    theString=fpReplaceAll(theString,fpSubmitFormDelimiter,fpSubmitFormDelimiterEscaped);
    
    return theString;
  
}

// unescape fp delimiters
function fpUnescape(str){

    var theString = str;
    
    theString=fpReplaceAll(theString,fpInFieldDelimiterEscaped,fpInFieldDelimiter);
    theString=fpReplaceAll(theString,fpFieldDelimiterEscaped,fpFieldDelimiter);
    theString=fpReplaceAll(theString,fpFormDelimiterEscaped,fpFormDelimiter);
    theString=fpReplaceAll(theString,fpCursorDelimiterEscaped,fpCursorDelimiter);
    //theString=fpReplaceAll(theString,fpSubmitFormDelimiterEscaped,fpSubmitFormDelimiter);//- the response does not contains the submitting form name
    
    theString= fpReplaceAllSmart(theString,"\\\\","\\");
    return theString;
     
}

// escape +
function fpEncodeText(str){
    var encodedString = escape(str);
	encodedString = fpReplaceAll(encodedString,"+", "%2B");
	return encodedString;		
}

// replace all using str.replace
function fpReplaceAll(strInput,strTarget,strSubString){
        var strText = strInput;
        var intIndexOfMatch = strText.indexOf( strTarget );

        while (intIndexOfMatch != -1){

            strText = strText.replace( strTarget, strSubString );
            intIndexOfMatch = strText.indexOf( strTarget ); 
        }
        
        return strText;
}

// replace all without using str.replace
function fpReplaceAllSmart(strInput,strTarget,strSubString){
        var strText = strInput;
        var intIndexOfMatch = strText.indexOf( strTarget );
        if(intIndexOfMatch==-1){
            return strText;
        }
        
        var strTextReplaced = "";
        var start=0;
        while(intIndexOfMatch!=-1){
            strTextReplaced+=strText.substring(start,intIndexOfMatch);
            strTextReplaced+=strSubString;
            start=intIndexOfMatch+strTarget.length;
            intIndexOfMatch = strText.indexOf(strTarget,start);
        }
        if(start<strText.length){
            strTextReplaced+=strText.substring(start,strText.length);
        }
       
        return strTextReplaced;
}

// End of Form Persistence util functions



// Form Persistence functions 

//defect 196787 Input field should be empty while create credential store.
//returns true if currently edited form is submited
function fpCheckIsCurrentFormSubmited() {
        var result = false;
        if (fpIsCurrentFormSubmited == true) {
            if ((fpSubmitFormName != null) && (fpSubmitFormName != '') && (fpCurrentFormSubmitedName == fpSubmitFormName)) {
                result = true;
            }
        }
        return result;
}

/**
* Cross-browser code to add handle event function for HTML DOM element.
* @parameter element dom element - The HTML DOM element - source of the event.
* @parameter eventName string - The name of event. Example 'click'.
* @parameter functionEventHandler function - The function which handles the event.
* @parameter toCaptureEvent boolean - Only for firefox. If true will registers to capture all events of the specified type 
*           and lower elemtent will not handle the event.
*/
function fpAddEventHandler(element, eventName, functionEventHandler, toCaptureEvent) {
	if (!toCaptureEvent) {
		toCaptureEvent = false;
	}
	if (element) {
		if (element.addEventListener){
			//Firefox
			element.addEventListener(eventName, functionEventHandler, toCaptureEvent); 
		} else if (element.attachEvent){
			//IE
			element.attachEvent('on' + eventName, functionEventHandler);
		}
	}
} // end of fpAddEventHandler()

// handles window unload event and persists data.
function fpWindowUnloadHandler() {
    
	//check for refresh of page in browser
	if (!fpCheckIsCurrentFormSubmited()) {
			fpResetSubmitForm();
	}
	fpSave();   
}

//check to see if the function was loaded
var _fploaded = false;
function _fpCheckLoad(){
	if (!_fploaded){
		fpFetch();
	}
}

// Add the Form Persistence event handlers
function fpAddHandlers(pageId){
		
		    fpCurrentPageId = pageId;

    		// persist data on unload
    		fpAddEventHandler(window, "unload", fpWindowUnloadHandler); 
    		// fetch data on load
    		_fploaded = false;
    		fpAddEventHandler(window, "load", fpFetch); 
    		//check to see if the page is loaded.  Wait for 500 milliseconds to see if fpFetch was called this is required for Firefox.  Sometimes 
    		//load event does not get called
		    setTimeout( '_fpCheckLoad();', 500 );
    		
    		//add event handlers for finding out the submiting form name and last focused element
        if (window.opera || (!document.all) ){//for FireFox and Opera
          
			fpAddEventHandler(window, "click", fpSaveSubmitForm);
			fpAddEventHandler(window, "keyup", fpSaveSubmitForm);
          
            // do not add fpHandlers if these frames do not exists
            if(parent && parent.frames){
                if(parent.frames.header){
                   fpAddEventHandler(parent.frames.header, "click", fpResetSubmitForm);
                   fpAddEventHandler(parent.frames.header, "keyup", fpResetSubmitForm);
                } 
                
                if(parent.frames.navigation){
                   fpAddEventHandler(parent.frames.navigation, "click", fpResetSubmitForm);
                   fpAddEventHandler(parent.frames.navigation, "keyup", fpResetSubmitForm);
                }
				if(parent.frames.taskbar){
                   fpAddEventHandler(parent.frames.taskbar, "click", fpResetSubmitForm);
                   fpAddEventHandler(parent.frames.taskbar, "keyup", fpResetSubmitForm);
				}
             }
    
      	 
      	} else {//for IE
      	
      	  fpAddEventHandler(window.document, "focusin", fpSaveSubmitForm);
      	  fpAddEventHandler(window.document, "focusout", fpSaveSubmitForm);
      	  
      	}	
      	
}// end of fpAddHandlers(pageId)


// Save submitting form name
function fpSaveSubmitForm(evt){
	
      var target=null;
      if (!evt){
            evt = window.event;
      }
      
      if (evt.target) {//for FireFox
            target = evt.target;
      }else if (evt.srcElement) {//for IE
            target = evt.srcElement;
      }

      if(target.form){
        fpFocusedElementName      = target.name;
        fpSubmitFormName          = fpConstructFormName(target.form);
        fpFocusedElementFormName  = fpConstructFormName(target.form);
        
	    //Added save current submited form - defect 196787 Input field should be empty while create credential store.
        if (target.tagName.toUpperCase() == "INPUT" && target.type.toUpperCase() == "SUBMIT") {
          fpIsCurrentFormSubmited = true;
          fpCurrentFormSubmitedName = fpSubmitFormName;
        }

      }else{      
	      //A href fix - find submitting formName when one clicks on A href or IMG
	      //Added FORM tagName - defect 196787 Input field should be empty while create credential store.
	      if (target != null && (target.tagName == 'FORM' || target.tagName == 'A' || target.tagName == 'IMG')) {
			//Search the parent tree to get form element
			var searchedFormElm = null;
			
			try {
				var searchedFormElm = fpGetAncestorByNodeName(target, 'FORM');
			} catch(e) {
				//eat up any exceptions;
			}
			if (searchedFormElm != null && searchedFormElm.name) {
				fpSubmitFormName = fpConstructFormName(searchedFormElm);
				fpFocusedElementName      = '';
				fpFocusedElementFormName  = '';
			} else {
				fpFocusedElementName      = '';
				fpSubmitFormName          = '';
			  	fpFocusedElementFormName  = '';
			}
	      } else {
		  fpFocusedElementName      = '';
		  fpSubmitFormName          = '';
		  fpFocusedElementFormName  = '';
		}
      }
      
}// end of fpSaveSubmitForm(evt)

//save submitting form name 
function fpSaveSubmitFormOnKeyUp(evt){
	
  	  if(evt.which){ //FireFox 
        if(evt.which==9){//TAB 
          fpSaveSubmitForm(evt);
        } 
      }
      
} // end of fpSaveSubmitFormOnKeyUp(evt)

//reset submitting form name 
function fpResetSubmitForm(){

       fpSubmitFormName="";
       
}// end of fpResetSubmitForm()

//returns current pageId
function fpGetPageId(){

	if (IscPages.currentPageId == null ) {
		IscPages.init();
	}
	return IscPages.currentPageId;
	
}// end of fpGetPageId()

//returns true if current page is form persitence enabled
function fpIsCurrentPageFPEnabled() {

	if ((fpCurrentPageId != null) && ('undefined' != typeof fpCurrentPageId) && (fpCurrentPageId.indexOf(fpGetPageId()) != -1)) {
		return true;
	}
	return false;
}//end of fpIsCurrentPageFPEnabled

//persist the form data using Axax request
function fpSave( evt, pageElem ) {	//185366
    if(fpPreSave()){
        if(!fpSkipPersistenceOnUnload){
        
           var fpPageAsString= "";
           
           if(fpPreSerialize()){
                fpPageAsString = fpSerializePage( pageElem );	//185366
           }
           fpPostSerialize();
           
           if (fpIsCurrentPageFPEnabled()) {
                fpMakeAjaxCall("putCache",fpAjaxPutCacheResponseHandler,fpPageAsString);
           }
              
        }
    }
	
}// end of fpSave()

//fetch the current page persisted data using Axax request
function fpFetch( evt, pageElem ) {	//185366
		_fploaded = true;

	if (fpIsCurrentPageFPEnabled()) {
	      if(fpPreFetch()){             
              fpMakeAjaxCall("getCache",fpAjaxGetCacheResponseHandler,'','');
	      } else {
				fpPostFetchAlways();
	      }
	} else {
		fpPostFetchAlways();
	}
	
}

// Form Persistence Ajax specific functions

// create XMLHttpRequest
function fpCreateXMLHttpRequest() {
	// 185366 Start (return new XMLHttpRequest object rather than using global object)
	   var tmpXHR = null;
      try {
        tmpXHR = new XMLHttpRequest();
      } catch (trymicrosoft) {
        try {
          tmpXHR = new ActiveXObject("Msxml2.XMLHTTP");
        } catch (othermicrosoft) {
          try {
            tmpXHR = new ActiveXObject("Microsoft.XMLHTTP");
          } catch (failed) {
            tmpXHR = false;
          }
        }
      }
      return( tmpXHR );
	  // 185366 End
}// end of fpCreateXMLHttpRequest()
  
// make Form Persistence Ajax request
function fpMakeAjaxCall(fpRequestType,fpAjaxResponseHandler,fpTextToPersist){
  
    var pXHR = fpCreateXMLHttpRequest();	// 185366 get discrete pXHR object rather than using global fpXmlHttpRequest object
    if(!pXHR){
       alert("Cannot create XMLHttp Request");
      return;
    }
    
    var pageId = fpGetPageId();
    var fpHttpParameters='RT='+fpRequestType+'&POID='+pageId+'&ISCPersistText='+escape(fpTextToPersist);//escape(escape(fpTextToPersist));

	// 185366 Start (replace fpXmlHttpRequest with pXHR)
	pXHR.onreadystatechange = function() {fpAjaxResponseHandler( pXHR );}	// 185366 Also modify onreadystatechange to call func passing pXHR
    pXHR.open(fpHttpMethod, fpUrl, true);
    pXHR.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    pXHR.setRequestHeader("Content-length", fpHttpParameters.length);
    pXHR.setRequestHeader("Connection", "close");
    pXHR.send(fpHttpParameters);
	// 185366 End
  
}// end of fpMakeAjaxCall(fpRequestType,fpAjaxResponseHandler,fpTextTpPersist)

// hadle get cache Ajax response
function fpAjaxGetCacheResponseHandler( pXHR ){	//185366
	// 185366 Start (replace fpXmlHttpRequest with pXHR)
 	try{
        if (pXHR.readyState == 4){
            if (pXHR.status == 200){
            
                var persistedText = pXHR.responseText;
                persistedText = unescape(persistedText);
                persistedText = persistedText.replace(/^\s*|\s*$/g,"");
                
                if(fpPreDeserialize()){
                    fpDeSerializePage(persistedText);
                    fpPostDeserialize();
                }
                
				//FF3 bug need to wait until post fecth is defined
                fpPostFetchWait();
                
                fpPostFetchAlways();
                
                
            }else if (pXHR.status == 404){
                 alert("Form Persistence request URL does not exist : "+fpUrl);
            }else{
                 alert("Form Persistence error: status code is " + pXHR.status);
            }
        }   
    }catch(err){
        // do nothing pXHR is still not created
    }
	// 185366 End
}// end of fpAjaxGetCacheResponseHandler()


// hadle put cache Ajax response
function fpAjaxPutCacheResponseHandler( pHXR ){	// 185366
    
    //do nothing on send data to server
    // otherwise get the error : pXHR is not defiend
    
}// end of fpAjaxPutCacheResponseHandler()

// End of Form Persistence Ajax specific functions


// check if an element ican be serialized
function fpIsElementSerializable(elementType){

   for(var i=0;i< fpSerializableElementTypes.length;i++){
  
  	      if(fpSerializableElementTypes[i]==elementType){
  	         return true;
          }
          
  }
  return false;
}// end of fpIsElementSerializable

// serialize the current page
// 185366 Start (use a specified page element rather than using the whole document)
function fpSerializePage( pageElem ){
	if( pageElem == null ) pageElem = document.body;
    								
    var pageAsString      =   '';
    var formAsString      =   '';
    var elementAsString   =   '';

	var forms = fpGetElementsByNodeName( pageElem, "form" );
	//console.info( "forms: " + forms.length );
  	
  	// iterate trhough all forms of the document
  	for( var f=0 ; f < forms.length ; f++ ){
  	   
  	     formAsString  = '';
  	     
  	     // check if the current form is the submiting form 
         if(fpConstructFormName(forms[f])==fpSubmitFormName){
  	     //if(forms[f].name==fpSubmitFormName){
  	       continue;//skip the submittig form 
         }
         
		 formElement = forms[f];
         
         formAsString = fpConstructFormName(formElement);
         formAsString  +=  fpFieldDelimiter;
		 
  	     //iterate through all fileds of the form
  	     for(  var e=0 ; e < forms[f].elements.length ; e++ ){
  	       
  	         elementAsString   =   '';
              
             elementType = forms[f].elements[e].type;
             
  	         // check if the field chan be serialized
  	         if(!fpIsElementSerializable(elementType)){
  	           continue;
             }
             
             //serialize the current element
             
             elementAsString  +=  fpEncodeText(fpEscape(forms[f].elements[e].name));
             elementAsString  +=  fpInFieldDelimiter;
              
             if( (elementType=="checkbox") || (elementType=="radio")){   
                  
                  // for checkbox or radio buttons save alse the value in case have
                  // a couple of checkboxes with the same name
                    elementId = forms[f].elements[e].id ? forms[f].elements[e].id : "";
                    elementAsString  +=   fpEncodeText(fpEscape(elementId));
                    elementAsString  +=  fpInFieldDelimiter;

                  elementAsString  +=  fpEncodeText(fpEscape(forms[f].elements[e].value));
                  elementAsString  +=  fpInFieldDelimiter;
                  elementAsString  +=  forms[f].elements[e].checked;
                  
             } else if ( (elementType=="select-one") ){
             
                 elementAsString  +=  forms[f].elements[e].selectedIndex;
                 
             } else if ( (elementType=="select-multiple") ){
             
                   for (var o = 0; o < forms[f].elements[e].options.length; o++) {
                   
    	      		     if ( forms[f].elements[e].options[o].selected ) {
    	      		     
    	      		        elementAsString+=o;
    	      		        elementAsString+=fpInFieldDelimiter;
    	      		        
    	      	      	}
    	      	      	
    	           	 }	
                   elementAsString = elementAsString.substring(0,elementAsString.length -fpInFieldDelimiter.length ); 
             } else{ 
                // for text, textarea and hidden fields
                elementAsString  += fpEncodeText(fpEscape(forms[f].elements[e].value));
             }
  	       
  	         // append element string to the form serialization
             formAsString      +=  elementAsString;
             formAsString      +=  fpFieldDelimiter;    
         }
         
         // append form serialization to the page serialization
         pageAsString += formAsString;
         pageAsString += fpFormDelimiter;
    }
// 185366 End    
    
    // add the focused element
    if(fpFocusedElementName){
      if(fpFocusedElementFormName){
         pageAsString+=fpCursorDelimiter;
         pageAsString+=fpFocusedElementFormName;
         pageAsString+=fpFieldDelimiter;
         pageAsString+=fpFocusedElementName;
      }
    }
    
    // add the submimitg form name
    if(fpSubmitFormName){
        pageAsString+=fpSubmitFormDelimiter;
        pageAsString+=fpSubmitFormName;
    }
    
    return pageAsString;
}//End of fpSerializePage

// 185366 Start (used to get forms on the specified element rather than using document.forms in the fpSerializePage function)
function fpGetElementsByNodeName( element, name ) {

	var result = new Array();
	try {
		var r = UIElement.getElementsByNodeName( element, name );
		if( r != null && r.length > 0 ) {
			result = result.concat( r );
		}
	}
	catch(e) {
		//wasn't a node
		//console.error(e);
	}
	return result;
} // End of fpGetElementsByNodeName
// 185366 End

// Begin of fpSplitString
/**
* Returns array of string - splited string in array of strings by delimiter, by skiping delimiters of array arrayOfAllDelimiter
* 
* $param str string - Splited string
* $param delimiter string - String by which splits str string
* $param arrayOfAllDelimiter array of string - skiped delimiters in string str.
*/
function fpSplitString(str, delimiter, arrayOfAllDelimiter){

  var result = [];
  if (str == null || typeof str != "string") {
    return result;
  }

  if (delimiter == null || typeof delimiter != "string") {
    return result;
  }

  if (arrayOfAllDelimiter == null || arrayOfAllDelimiter.length == null)    {
    return result;
  }

  var strLen = str.length;
  var indexOfDelimiter = strLen;
  var previousIndexOfDelimiter = 0;
  var positionString = 0;

  while(indexOfDelimiter >= 0 && indexOfDelimiter  <= strLen && positionString < strLen) {
    //get index position in str of delimiter starting from positionString index
    indexOfDelimiter = str.indexOf(delimiter, positionString);
	
    var minIndex = -1;
    var minValue = indexOfDelimiter;
	
    if (indexOfDelimiter == -1) {
      //delimiter not found in str. Copy to end of string
      indexOfDelimiter = str.length;
    } else {
      //Search for delimiter of array arrayOfAllDelimiter between positionString and indexOfDelimiter
      for(var j = 0; j < arrayOfAllDelimiter.length; j++) {
        var currentDelimiter = arrayOfAllDelimiter[j];

        //skip split delimiter
        if (delimiter == currentDelimiter) {
          continue;
        }

		//get index position in str of current delimiter starting from positionString index
        var pos = str.indexOf(currentDelimiter , positionString);

        
        if ((pos >= 0) && (pos < minValue)) {
          //found delimiter between position positionString and indexOfDelimiter in string str.
          minIndex = j;
          minValue = pos;
        }
      }
    }

    if (minIndex == -1) {
      //No delimiter of arrayOfAllDelimiter between positionString and indexOfDelimiter in string str.

	  //Copy sub string from previousIndexOfDelimiter to previousIndexOfDelimiter position
      var tempString = str.substr(previousIndexOfDelimiter, indexOfDelimiter - previousIndexOfDelimiter);
	  //add string to result array
      result = result.concat(tempString );
	  //advance the serach position by string lenght of delimiter
      positionString = indexOfDelimiter + delimiter.length;
	  //save begin position of next sub string to be copied
      previousIndexOfDelimiter = positionString;
    } else {
	  //found delimiter of arrayOfAllDelimiter between positionString and indexOfDelimiter in string str.
	  //skip this delimiter
      positionString = minValue + arrayOfAllDelimiter[minIndex].length;
    }
  }

  return result;
}
// End of fpSplitString

// deserialize a page and update the DOM 
function fpDeSerializePage(fpPageAsString){

  if(fpPageAsString===null){
    return;
  }
  
  fpPageAsString = fpUnescape(unescape(fpPageAsString));
  
  var arrayOfAllDelimiter = [fpInFieldDelimiter, fpFieldDelimiter, fpFormDelimiter, fpCursorDelimiter, fpSubmitFormDelimiter]
  var persistedArray      = fpSplitString(fpPageAsString, fpCursorDelimiter, arrayOfAllDelimiter);
  if(persistedArray.length<=0){
      return; // no data persisted  
  }
  
  var formsAsStringArray = fpSplitString(persistedArray[0], fpFormDelimiter, arrayOfAllDelimiter);
  
  // iterate through all the serialized forms
  for(  var f=0 ; f < formsAsStringArray.length ; f++ ){
  
		fromAsStringArray = fpSplitString(formsAsStringArray[f], fpFieldDelimiter, arrayOfAllDelimiter);
        
        formUniqueName = fromAsStringArray[0];
        
        form = fpGetFormElement(formUniqueName);
        if(!form){
            continue;
        }

        
        //iterate throught all the serialized fields
        for(var e=1;e<fromAsStringArray.length;e++){
            
            var elementAsStringArray = fpSplitString(fromAsStringArray[e], fpInFieldDelimiter, arrayOfAllDelimiter);
            
            var elementName   = elementAsStringArray[0];
            var elementValue  = elementAsStringArray[1];
            if ((elementValue == null) || (typeof elementValue == "undefined")) {
              continue;// no value saved - skip element
            }
            
            // find the element into the current form
            var element =  form.elements[elementName];
            if(!element){
              continue;// can not gind such element
            }
            
            // for checkboxes and radio buttons
            if(!element.type){
              //NodeList
               for(var i=0;i<element.length;i++){
                  if(element[i].id){
                        
                        elementId = elementAsStringArray[1];
                        if(element[i].id==elementId){
                            element=element[i];
                            break;
                        }
                  }else{
                      elementValue = elementAsStringArray[2];
                      if(element[i].value==elementValue){
                          element=element[i];
                          break;
                      }
                  }
               }
            }
            
           
            if(!element.type){
               continue;// can not find the element inside the NodeList
            }
            
            var elementType = element.type;
            
            
             if( (elementType=="checkbox") || (elementType=="radio")){ 
                if(element.id){
                    
                    if(element.id != elementAsStringArray[1]){
                        continue;
                    }
                }
               
                var isChecked = elementAsStringArray[3];
                isChecked = (isChecked=='true') ? true : false;
                element.checked=isChecked;
                  
             } else if ( (elementType=="select-one") ){
             
                  element.selectedIndex = elementValue;
                 
             } else if ( (elementType=="select-multiple") ){
             
                  for(var o=1; o < elementAsStringArray.length;o++){
                    var selectedIndex = elementAsStringArray[o];
                    element.options[selectedIndex].selected = true;
                  }
             } else{ 
               element.value=elementValue;
             }
            
        }
        
   }
   
   // set the cursor position
   
   //check if there is already portlet anchoring on, in this case we don;t want to override portletanchoring by cursor foucs
   try {
   	if(iscPrltAnchorActive) {
   	    return;   // skip cursor focus
   	}
   } catch(err) { 
   	//catch error if variable is not found. 
   }
   
   // check if the cursor position is persisted   
   if(persistedArray.length<=1){
      return;   // no cursor persisted
   }
  
   var cursorArray          = fpSplitString(persistedArray[1], fpFieldDelimiter, arrayOfAllDelimiter);
   var cursorFormName       = cursorArray[0];
   var cursorElementName    = cursorArray[1];
   
   cursorForm = fpGetFormElement(cursorFormName);
   if(!cursorForm){
    return ; // no such form 
   }
   
   
   
   var focusedElement      =  cursorForm.elements[cursorElementName];
   if(!focusedElement){
      return; // no such element
   }
   
  
   if(!focusedElement.type){
         //NodeList
         focusedElement=focusedElement[0];
   }
   
   if(!focusedElement){
           return;// can not find the element inside the NodeList
   }
  
    try{
    // set the focus
     focusedElement.focus();
   }catch(err){
        //do nothing - remain the element unfocused
   }

}//End of fpDeSerializePage

function fpConstructFormName(element){

    formName= element.name;
    portletUniqueId = "";		 
	hasParent = true;
	while (hasParent) {
		eid = element.id;
		if (eid != null) {
			eidarr = eid.split(fpPortletIdDelimiter);
			if (eidarr[0] == fpPortletIdPrefix){
				portletUniqueId = fpPortletIdPrefix + fpPortletIdDelimiter +eidarr[1]+fpPortletIdDelimiter+eidarr[2];				
				hasParent = false;
			}
			element = element.parentNode;
			if (element === null) {
				hasParent = false;
			}

		} else {
			hasParent = false;
		}
	}
	if (portletUniqueId != "") {
		formName  +=  fpPortletIdDelimiter + portletUniqueId; 
		return formName;
	} else {
		return fpSubmitFormName;
	}
		
}

function fpGetFormElement(formUniqueName){

        formUniqueNameArr = formUniqueName.split(fpPortletIdDelimiter);
		portletId = formUniqueNameArr[1]+fpPortletIdDelimiter+formUniqueNameArr[2]+fpPortletIdDelimiter+formUniqueNameArr[3];
        found = false;
		form  = null;
		for( var i=0 ; i < document.forms.length ; i++ ){			
			element = document.forms[i];
			hasParent = true;
			if (found) {
				continue;
			}
			while (hasParent) {
				element = element.parentNode;
				if (element === null) {
					hasParent = false;
				} else {
					if (element.id == portletId) {
                        if(document.forms[i].name==formUniqueNameArr[0]){
                            form = document.forms[i];
                            found = true; 
                            hasParent = false;	
                            break;                            
                        }
					}
				}
			}
			
		} 
        
        form = (!found) ? false : form;
        return form;
		
}

// look up ancestor tree to get form element
function fpGetAncestorByNodeName( element, name ) {
	if( element == null ) {
		return( null );
	}
	else if( element.nodeName.toLowerCase() == name.toLowerCase() ) {
		return( element );
	}
	else {
		return( fpGetAncestorByNodeName( element.parentNode, name ) );
	}
}

// Form Persistence callbacks

function fpPreSerialize(){// is invoked before the page is serialized
    return true;
}
function fpPostSerialize(){// is invoked after the page is serialized
}
function fpPreDeserialize(){// is invoked before the page is deserialized 
    return true;
}
function fpPostDeserialize(){// is invoked after the page is deserialized 
}
function fpPreFetch(){// is invoked before getCache Ajax request is made 
    return true;
}

//need to wait for inline javascript content to be loaded first.  FF3 bug (https://bugzilla.mozilla.org/show_bug.cgi?id=444322)
function fpPostFetchWait() {
  if( fpPostFetch() != 9999 ) {
    fpPostFetch();
  } else {
  	//try 60 times before quiting... 600 milliseconds.
  	if (fpPostFetchTryCount < 60){
	    setTimeout( 'fpPostFetchWait();', 10 );
	  	fpPostFetchTryCount++;
	    }
    else
       fpPostFetch();
  }
}

function fpPostFetch(){// is invoked after getCache Ajax response is received 
//dummy call to make sure that the content is set inline on the page
return 9999;
}

function fpPreSave(){// is invoked before putCache Ajax request is made 
    return true;
}
function fpPostFetchAlways(){// is invoked after getCache Ajax response is received or if Form Persistence is disabled for currrent page
}
// End of Form Persistence callbacks

// End of Form Persistence functions 
