/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2007 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
/*******************************************************************************
 * CMVC Location: TIPChartPortlet/WebContent/js/ibm/tivoli/tip/charts/dijit/ChartProperties.js, tipcharts, tip2
 * Version:       1.18
 * Last Modified: 5/8/08
 *******************************************************************************/
dojo.provide("ibm.tivoli.tip.charts.dijit.ChartProperties");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Dialog");
dojo.require("dijit.Toolbar");
dojo.require("dijit.form.Form");
dojo.require("dijit.form.ValidationTextBox");
dojo.require("dijit.form.TextBox");
dojo.require("dijit.form.NumberSpinner");
dojo.require("dijit.layout.TabContainer");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.form.CheckBox");  // also contains RadioButton
dojo.require("dijit.form.Textarea");
dojo.require("dijit.form.FilteringSelect");
dojo.require("ibm.tivoli.tip.dijit.TIPButton");
dojo.require("ibm.tivoli.tip.charts.Version");
dojo.require("ibm.tivoli.tip.Version");

// NLS
dojo.requireLocalization("ibm.tivoli.tip.charts.dijit", "chart_resources");


dojo.declare("ibm.tivoli.tip.charts.dijit.ChartProperties",
            [ dijit._Widget, dijit._Templated ],
{
	templatePath: dojo.moduleUrl("ibm.tivoli.tip.charts.dijit","templates/ChartProperties.html"),
	widgetsInTemplate: true,
	namespace: null,
	contextPath: null,
	formURL: null,
	
	constructor: function() {
	    this.resources_ = dojo.i18n.getLocalization("ibm.tivoli.tip.charts.dijit", "chart_resources");
	    this.connections = [];
	    this.chartingVersion = dojo.string.substitute(this.resources_.CHARTING_VERSION, { 0: ibm.tivoli.tip.charts.Version.getVersion() });
	    console.log ("chartingVersion: " + this.chartingVersion);
	    this.tipDojoVersion = dojo.string.substitute(this.resources_.TIPDOJO_VERSION, { 0: ibm.tivoli.tip.Version.getVersion() });
	    console.log ("tipDojoVersion: " + this.tipDojoVersion);
	    this.dojoVersion = dojo.string.substitute(this.resources_.DOJO_VERSION, { 0: dojo.version });
	    console.log ("dojoVersion: " + this.dojoVersion);
	},
	
	postCreate: function () {
		this.connections.push (dojo.connect (this.cancelButton, "onclick", this, "hide"));
		console.log ("connected cancel button with hide");
	},
	
//	postCreate: function () {
//		this.inherited (arguments);
//		var tabs = new dijit.layout.TabContainer();
//		var div = dojo.doc.createElement( 'DIV' );
//		var tab1 = new dijit.layout.ContentPane(
//			{	selected: true,
//				title: "GENERAL"
//			}, div);
//		tabs.addChild (tab1);
//		this.dialog.domNode.appendChild (tabs.domNode);
//	},
	
	show: function () {
		console.info ("enter ChartProperties");
		console.log ("this.dialog is: ");
		console.log (this.dialog);
		this.dialog.show();
		dijit.byId (this.namespace + "tabs").resize();
	},
	
	hide: function () {
		console.log("enter ChartProperties.hide");
		this.dialog.hide();
	},
	onOK: function () {
		dijit.byId (this.namespace + "chartWidget").dlgOKPressed();
	},
	onCancel: function () {
		this.hide();
		var chartWidget = dijit.byId (this.namespace + "chartWidget");
		
		var nameField = dojo.byId(this.namespace + "chartName");
		var heightField = dojo.byId(this.namespace + "height");
		var widthField = dojo.byId (this.namespace + "width");
		var showLegendField = dijit.byId (this.namespace + "showLegendCB");
		var descriptionField = dijit.byId(this.namespace + "description");
		var chartRadio = dijit.byId (this.namespace + "chartSelected");
		var tableRadio = dijit.byId (this.namespace + "tableSelected");
		var checkForUpdatesCB = dijit.byId (this.namespace + "checkForUpdatesCB");
		var receiveContextRadio = dijit.byId(this.namespace + "contextualParametersSelected");
		var useDefaultContextRadio = dijit.byId(this.namespace + "defaultParametersSelected");
		var showLastUpdated = dijit.byId (this.namespace + "showLastUpdated");
		var showNameInChart = dijit.byId (this.namespace + "showNameInChart");

		nameField.value = chartWidget.oldName_;
		descriptionField.setValue (chartWidget.oldDescription_);
		heightField.value = chartWidget.oldHeight_;
		widthField.value = chartWidget.oldWidth_;
		showLegendField.setChecked (chartWidget.oldShowLegend_);
		chartRadio.setChecked (chartWidget.oldChartRadio_);
		tableRadio.setChecked (!chartWidget.oldChartRadio_);
		checkForUpdatesCB.setChecked (chartWidget.oldCheckForUpdates_);
		useDefaultContextRadio.setChecked (!chartWidget.oldReceiveContext_);
		receiveContextRadio.setChecked (chartWidget.oldReceiveContext_);
		showLastUpdated.setChecked (chartWidget.oldShowLastUpdated_);
		showNameInChart.setChecked (chartWidget.oldShowNameInChart_);

		var paramDiv = dijit.byId (this.namespace + "parametersDiv");
		paramDiv.resetParameters();
	},
	destroy: function () {
		console.log ("enter ChartProperties.destroy");
		dojo.forEach (this.connections, function (item) {
			dojo.disconnect (item);
		});
		
		this.dialog.destroy();

		this.inherited (arguments);
		console.log ("exit ChartProperties.destroy");
	}
	
});

	
