/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2007 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/

dojo.provide("ibm.tivoli.tip.charts.dijit.ChartSelectorWidget");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Toolbar");
dojo.require("ibm.tivoli.tip.dijit.TIPButton");
dojo.require("dijit.form.ComboBox");
dojo.require("ibm.tivoli.tip.dojo.Global");
dojo.require("ibm.tivoli.tip.dojo.Server");
dojo.require("ibm.tivoli.tip.charts.dojo.Global");
dojo.require("ibm.tivoli.tip.dijit.Breadcrumb");
dojo.require("ibm.tivoli.tip.dijit.TIPTable");


// NLS
dojo.requireLocalization("ibm.tivoli.tip.charts.dijit", "chart_resources");


// define the widget class
dojo.declare (
	"ibm.tivoli.tip.charts.dijit.ChartSelectorWidget", 
    [ dijit._Widget, dijit._Templated ],
{
    datasource_ : "",
    namespace_ : "namespace1_",
    groupID_ : "",
    chartID_ : "",
    populateGroups: true,
    global: null,
    widgetsInTemplate: true,
    templatePath: dojo.moduleUrl("ibm.tivoli.tip.charts.dijit","templates/ChartSelectorWidget.html"),

	constructor: function() {
	    this.resources_ = dojo.i18n.getLocalization("ibm.tivoli.tip.charts.dijit", "chart_resources");	
	    this.chartsTable = null;
	    this.connections = [];
	},
	initialize: function() { 
	},
	postCreate: function() {
		this.inherited(arguments);
		this.global = ibm.tivoli.tip.dojo.Global.getSingleton(this.namespace_);
		
//		var selectGroupButton = dojo.byId (this.id + "selectGroupBtn");
//        dojo.connect(selectGroupButton, 'onclick', this, 'onSelectGroup');
		this.connections.push (dojo.connect(dojo.byId(this.id + 'groupSelector'),'onchange', this, 'onSelectGroup'));

		this.makeChartsTable();        
        
        if (this.populateGroups) {
	        this.populateSelectGroup ();
	    }
	},
	setDataSource: function (datasource) {
		if (this.datasource_ != datasource) {
			this.datasource_ = datasource;
			this.clearSelectChart();
			this.clearSelectGroup();
			this.populateSelectGroup();
		}
	},
	showConnectionManager: function () {
		dojo.publish ("/com.ibm.tivoli.tip.charts/" + this.namespace_ + "#showConnectionManager", []);
	},
	showCursorWait: function() {
		if (dojo.byId (this.id + "chartSelectorDiv")) {
			dojo.byId (this.id + "chartSelectorDiv").style.cursor = "wait";
//			dojo.byId (this.id + "selectGroupBtn").style.cursor = "wait";
//			dojo.byId (this.id + "selectChartBtn").style.cursor = "wait";
			dojo.byId (this.id + "tbl_applicationCharts").style.cursor = "wait";
			dojo.byId (this.id + "groupSelector").style.cursor = "wait";
			dojo.byId (this.id + "groupRefresh").style.cursor = "wait";
		}
	},
	showCursorDefault: function() {
		if (dojo.byId (this.id + "chartSelectorDiv")) {
			dojo.byId (this.id + "chartSelectorDiv").style.cursor = "default";
//			dojo.byId (this.id + "selectGroupBtn").style.cursor = "default";
//			dojo.byId (this.id + "selectChartBtn").style.cursor = "default";
			dojo.byId (this.id + "tbl_applicationCharts").style.cursor = "default";
			dojo.byId (this.id + "groupSelector").style.cursor = "default";
			dojo.byId (this.id + "groupRefresh").style.cursor = "default";
		}
	},
	
	
	populateSelectGroup: function() {
		this.showCursorWait();
		var howTo = { showMsg : true, callback: dojo.hitch (this, this.onError) };
   
		var kw = {
             content:   {
                         command: "listGroups",
                         arg_datasource: encodeURI(this.datasource_)
                        },
             onExc: howTo,
             onResponse:{
                         callback: dojo.hitch(this, this.populateSelectGroupCallback)
                        }
         };
	
        ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).get( kw );			
	},
	onError: function () {
		console.log ("enter ChartSelectorWidget.onError");
		this.showCursorDefault();
	},
	clearSelectGroup: function () {
		var groupSelector = dojo.byId (this.id + "groupSelector");
		groupSelector.options.length = 0;
	},
	populateSelectGroupCallback: function(data, ioArgs) {
		console.log ("populating selectgroup.  groupID: " + this.groupID_);

		if (data.objectType === "serverException") {
			var context = ibm.tivoli.tip.charts.dojo.Global.getSingleton(this.namespace_);
			context.handleServerException (data);
		}
				
		var groupSelector = dojo.byId (this.id + "groupSelector");
		var selected = false;
		var val = null;
		this.clearSelectGroup();

		groupSelector.options[0] = new Option(this.resources_.SELECT_GROUP, this.resources_.SELECT_GROUP);
		for (var i=1; i<data.length+1; i++) {
			groupSelector.options[groupSelector.options.length] = new Option (data[i-1].label, data[i-1].id);
			if (data[i-1].id == this.groupID_) {
				selected = true;
			}
		}
		this.showCursorDefault();

		console.log ("populateSelectGroupCallback. selected: " + selected);
		console.log ("populateSelectGroupCallback. groupSelector entries: " + groupSelector.options.length);
		if ((!selected) && (groupSelector.options.length > 0)) {
			console.log ("populateSelectGroupCallback. selecting");
			groupSelector.options[0].selected = true;
			selected = true;
		}
				
		if (selected) {
			this.onSelectGroup();
		}
	},
	onSelectGroup: function() {
		var group = dojo.byId(this.id + "groupSelector").value;
		// set the value for submit so Portlet Prefs can pick it up.
		dojo.byId (this.namespace_ + "groupIDH").value = group;
		this.updateChartsTable(group);
	},
	onRefreshGroup: function() {
		this.showCursorWait();
		var howTo = { showMsg : true, callback: dojo.hitch (this, this.onError) };
   
		var kw = {
             content:   {
                         command: "listGroups",
                         arg_datasource: encodeURI(this.datasource_),
						 arg_clearcache: "true"
                        },
             onExc: howTo,
             onResponse:{
                         callback: dojo.hitch(this, this.populateSelectGroupCallback)
                        }
         };
	
        ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).get( kw );			
	},	
	clearSelectChart: function () {
		var args = [];
		args.clear = true;
	
		this.chartsTable.refreshWithArgs(args);
		dojo.byId (this.namespace_ + "chartIDH").value = "";
//		var chartSelector = dojo.byId (this.id + "chartSelector");
//		chartSelector.options.length = 0;
	},
//	populateSelectChartCallback: function (data, ioArgs) {
//		console.log ("enter populateSelectChartCallback; chartID: " + this.chartID_);
//		if (data.objectType === "serverException") {
//			var context = ibm.tivoli.tip.charts.dojo.Global.getSingleton(this.namespace_);
//			context.handleServerException (data);
//		}
		
//		var chartSelector = dojo.byId (this.id + "chartSelector");
//		var selected = false;

//		console.log ("in populateSelectChartCallback. data length: " + data.length);
//		this.clearSelectChart();
		
//		for (var i=0; i<data.length; i++) {
//			console.log ("adding chart: " + data[i].id);
//			chartSelector.options[chartSelector.options.length] = new Option (data[i].label, data[i].id);
//			if (data[i].id == this.chartID_) {
//				chartSelector.options[i].selected = true;
//				console.log ("selected chart: " + data[i].id);
//				selected = true;
//			} else {
//				console.log ("chart: " + data[i].id + " does not match " + this.chartID_);
//			}
//		}
//		this.showCursorDefault();
//
//		if (selected) {
//			this.onSelectChart();
//		}
//	},
	onSelectChart: function() {
		console.log ("enter onSelectChart");		
		var group = dojo.byId(this.id + "groupSelector").value;
		var selectedRow = this.chartsTable.getSelectedRowIndexes();
		if ((selectedRow) && (selectedRow.length > 0)) {
			var chartID = this.chartsTable.getValueAt (selectedRow, 3);
			var chartName = this.chartsTable.getValueAt (selectedRow, 1);
			console.log ("calling getChartDefinition with group: " + group + ", chartID: " + chartID);
			// copy the chart ID to a hidden field so it can be read by the server on a post
			dojo.byId (this.namespace_ + "chartIDH").value = chartID;
	        this.getChartDefinition(group, chartID, chartName);
	    }
	},
	getChartDefinition: function (group, chartID, chartName) {
		this.showCursorWait();
//		var chartWidget = dijit.byId (this.namespace_ + "chartWidget");
//		var errorHandler = { showMsg : true, callback: dojo.hitch (chartWidget, chartWidget.onError) };
		var howTo = { showMsg : true, callback: dojo.hitch (this, this.onError) };


		var kw = {
             content:   {
                         command: "getChartDefinition",
                         arg_datasource: encodeURI(this.datasource_),
						 arg_groupID: encodeURI(group),
						 arg_chartName: encodeURI(chartName),
						 arg_chartID: encodeURI(chartID)
                        },
	         onExc: howTo,
             onResponse:{
                         callback: dojo.hitch(this, this.populateGetChartDefinitionCallback)
                        }
         };

        ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).get( kw );			
	},
	populateGetChartDefinitionCallback: function (data, ioArgs) {
//		var group = dojo.byId(this.id + "groupSelector").value;
		this.onWebServiceChartSelection(data[0].chartSourceType, data[0].connectionName, data[0].groupID, data[0].id);
	},
	onWebServiceChartSelection: function (chartSrcType, connectionName, groupID, chartID) {
		var clearPreferences = true;
		this.showCursorDefault();		
		var selectedRow = this.chartsTable.getSelectedRowIndexes();
		var chartName = null;
		if ((selectedRow) && (selectedRow.length > 0)) {
			chartName = this.chartsTable.getValueAt (selectedRow, 1);
		}
		console.log ("in onWebServiceChartSelection with chartName: " + chartName);
		
		dijit.byId (this.namespace_ + "chartWidget").onReportSelection (
			chartSrcType,
			connectionName,
			groupID,
			chartID,
			chartName,
			clearPreferences,
			true);		
	},
	showConnectionManager: function () {
		dijit.byId (this.namespace_ + "mainChartNavigatorDiv").showConnectionManager();
	},
	showChartNavigator: function() {
		dijit.byId (this.namespace_ + "mainChartNavigatorDiv").showChartNavigator();
	},
	makeChartsTable: function () {
		console.log ("enter makeChartsTable");
		
		var global = ibm.tivoli.tip.dojo.Global.getSingleton (this.namespace_);
		this.chartsTable = new ibm.tivoli.tip.dijit.TIPTable({
					global: global,
					tableID: "tbl_applicationCharts",
					multiSelect: false,
					cmProvider: null,
					width: "100%",
					gridParms: {autoWidth: false, autoHeight:false, rowsPerPage: "10", rowCount: "5" },
					id: this.id + "tbl_applicationCharts"
				}, 
				dojo.byId (this.id + "tbl_applicationCharts"));
				
		this.chartsTable.startup();
		this.contributeToolbar();
		this.contributeFooter();
		dojo.subscribe (this.chartsTable.id + "#LoadComplete", this, "onTableLoad");
		this.resize();
		console.log ("exit makeChartsTable");
	},
	onTableLoad: function () {
		console.log ("enter ConnectionManagerWidget.onTableLoad");
		this.resize();
	},
	resize: function () {
		console.log ("enter ChartSelectorWidget.resize");
		var portletSize = iscPortlet.getPortletSize(this.global.iscPortletNamespace);
		var size = { w: portletSize.available.w, h: portletSize.available.h };
		if (size.w === undefined) {
			// guess
			size.w = 800;
		} else if (isNaN(size.w)) {
			// guess
			size.w = portletSize.current.w;
		} 
		if (size.h === undefined) {
			// guess
			size.h = 200;
		} else if (isNaN(size.h)) {
			// guess
			size.h = 200;
		} 
		
		console.log ("size: ");
		console.log (size);
		dijit.byId (this.id + "tbl_applicationCharts").resize (size);
	},
	contributeToolbar: function () {
		var context = ibm.tivoli.tip.dojo.Global.getSingleton(this.namespace_);
		if (context.roles.admin) {
			var toolbar = this.chartsTable.getToolbar();
			var button = new ibm.tivoli.tip.dijit.TIPButton(
				{	label: this.resources_.CLEAR_CACHE, 
					id: this.id + "clearCacheButton",
					showLabel: true, 
				 	onClick: dojo.hitch (this, this.clearDesignCache) 
				});
			toolbar.addChild(button);
		}
	},
	contributeFooter: function () {
		var toolbar = this.chartsTable.getFooterToolbar(); //.getToolbar();

		var button = new ibm.tivoli.tip.dijit.TIPButton ({
			label: this.resources_.BACK,
			showLabel: true,
			onClick: dojo.hitch (this, this.showConnectionManager)
		});
		toolbar.addChild (button);

		button = new ibm.tivoli.tip.dijit.TIPButton ({
			label: this.resources_.FINISH,
			showLabel: true,
			onClick: dojo.hitch (this, this.onSelectChart)
		});
		toolbar.addChild (button);
	},
	clearDesignCache: function () {
		var kw = {
             content:   {
	             command: "clearCache",
	             arg_connectionID: encodeURI(this.datasource_)
                        },
             onResponse:{
                 callback: dojo.hitch(this, this.clearDesignCacheCallback)
                        }
         };
	
        ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).get( kw );			
	},
	clearDesignCacheCallback: function () {
		console.log ("design cache cleared");
	},
	updateChartsTable: function (group) {
		// TODO need a callback chartsTable.refresh so we can set the cursor back to normal
//		this.showCursorWait();
		if (group != this.resources_.SELECT_GROUP) {
			console.log ("enter updateChartsTable.  ds: " + this.datasource_ + ", group: " + group);
			var args = [];
			args.dataSource = encodeURI(this.datasource_);
			args.groupName = encodeURI(group);
		
			console.log ("in updateChartsTable. args: ");
			console.log (args);
		
			this.chartsTable.refreshWithArgs (args);
		}
	},
	destroy: function () {
		console.log ("enter ChartSelectorWidget.destroy");
		dojo.forEach (this.connections, function (item) {
			dojo.disconnect (item);
		});

//		this.destroyDescendants();
		this.inherited (arguments);
		console.log ("exit ChartSelectorWidget.destroy");
	}
});
