/*
 * Component Name: WAS.isc.isclite.cp
 * 
 * Licensed Materials - Property of IBM
 * 5724-I63, 5724-H88, 5655-N02, 5733-W70 
 * Copyright IBM Corp. 2006, 2007 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 * 
 */
 
// Form Persistence TaskBar specific functions


// add From Persistence handlers on the taskbar frame
function fpAddTaskBarHandlers(){
        
  if (window.Event){ // only for FireFox
  
  	if( parent.detail && parent.detail.fpCurrentPageId ){ // add handlers only if the page loaded in WorkArea frame is enabled for FP
  		    window.captureEvents(Event.CLICK);
  	  	 	window.onclick= fpResetSubmitForm;
  	  	 
  	  		window.captureEvents(Event.KEYPRESS); 
  	    	window.onkeypress = fpResetSubmitForm;
    }
    
  }
}// end fpAddTaskBarHandlers();

// reset submiting form name from the TaskBar
function fpResetSubmitForm(){

       if(parent.detail.fpCurrentPageId){
	      parent.detail.fpSubmitFormName="";
       }
}

function fpSkipPersistenceOnUnload(){

      if(parent.detail.fpCurrentPageId){
        parent.detail.fpSkipPersistenceOnUnload=true;
      }
}

function fpTaskBarDropDownListHandler(evt){
	var taskBarDropDownList             =  document.getElementById("PageAction");
	var taskBarDropDownListDestination  =  taskBarDropDownList.options[taskBarDropDownList.selectedIndex].value;
	
	if (taskBarDropDownListDestination == "EditPage")
	{
		// alert('Edit Page');
		if( parent.detail && parent.detail.IscPages && parent.detail.IscPages.currentPageId ) {

			//218616 - prevent Edit mode if any portlets are minimized/maximized
			if( pageContainsMinMaxPortlet( parent.detail.IscPages.currentPageId ) ) {
				alert( cannotEditMinMaxText );
				taskBarDropDownList.selectedIndex = 0;
				return( false );
			}

			var curPageElem = parent.detail.IscPages.getPageElementById( parent.detail.IscPages.currentPageId );
            taskBarDropDownList.options[taskBarDropDownList.selectedIndex].value="SaveAs";
            taskBarDropDownList.options[taskBarDropDownList.selectedIndex].text=saveAsText;
            taskBarDropDownList.selectedIndex = 0;
            // alert( "page id is: " + curPageElem.id );
 			parent.detail.customizer.enterCustomizeModeFromMenu( curPageElem );
		}
		return false;
	}
	if (taskBarDropDownListDestination == "SaveAs")
	{
		if( parent.detail && parent.detail.IscPages && parent.detail.IscPages.currentPageId ) {
			var curPageElem = parent.detail.IscPages.getPageElementById( parent.detail.IscPages.currentPageId );
			// alert( "page id is: " + curPageElem.id );
 			parent.detail.customizer.enterSaveAsFromMenu( curPageElem );
		}
		return false;
	}
	
	if(taskBarDropDownListDestination.indexOf("close")>=0){ // closing  focused page
    cleanPageResources(parent.detail.IscPages.currentPageId);
		fpSkipPersistenceOnUnload();
	}
  
	// go to the page
	if( top.Frameset.UseSM ) {
        
		SMUtils.RequestFragmentCollection( taskBarDropDownListDestination );
	}
	else {
		parent.detail.location=taskBarDropDownListDestination;
	}
}

//218616 - prevent Edit mode if any portlets are minimized/maximized
function pageContainsMinMaxPortlet( pageId ) {
	if( parent.detail.IscPages && parent.detail.IscPages.getPageObjectById ) {
		var pageObj = parent.detail.IscPages.getPageObjectById( pageId );
		var pageDiv = pageObj.element;

		//This doesn't work on FF3 due to Dojo bug 7075: http://trac.dojotoolkit.org/ticket/7075
		//This is cleaner however, and it would be nice to use it once we can get the Dojo fix.
		/* 
		var restoreAnchor = dojo.query( 'a[name^="IscRestore"]', pageDiv );
		if( restoreAnchor[0] ) {
			return( true );
		}
		*/

		// This _does_ work on FF3, apparently avoiding the Dojo 7075 bug.
		var images = dojo.query( 'img', pageDiv );
		for( i = 0; i < images.length; i++ ){
			if( images[i] && images[i].getAttribute && images[i].getAttribute( "src" ) != null ) {
				// Actual FF3 src URL: /ibm/console/ISCProxy/images/content/title_restore.gif
				// Note IE will fully qualify url, so use indexOf rather than exact matching
				if( images[i].getAttribute( "src" ).indexOf( "/ISCProxy/images/content/title_restore.gif" ) != -1 ) {
					return( true );
				}
			}
		}
	}
	return( false );
}

// Begin 177818: update taskbar contents via AJAX rather than reloading the whole frame
function taskBarObj(){}

taskBarObj.BODY_TAG_ID="BODYTAG";
taskBarObj.TRASH_DIV_ID="TRASH";
taskBarObj.TASKBAR_FRAGMENT_ID="taskbarFragment";

taskBarObj.dojocallback = function(data) {
	this.commoncallback( data );
};

taskBarObj.ajaxcallback = function( status, data ) {
	// If status = OK...
	if( status == 200) {
		this.commoncallback( data );
	}
	else {
		alert( "ajaxcallback error, status = " + status );
	}
};

taskBarObj.getElementById = function(element, id) {
    var result=null;
    try
    {
        if (element.id==id) {
//        	//console.info("found taskBarObj.getElementById(" + element.id + "," + id + ")");
            return(element);
        }
        if (element.hasChildNodes()) {
            var children = element.childNodes;
            for (var i = 0; i < children.length; i++) {
            	
                result=taskBarObj.getElementById(children[i],id);
                if (result!=null) {
//                	//console.info("taskBarObj.getElementById(" + result.id + "," + id + ")");
                    return(result);
                }
            }
        }
    }
    catch(e)
    {
        //no id
    }
   ////console.info("taskBarObj.getElementById(" + element.id + "," + id + ")");
    return(result);

};


/*
function TaskbarUpdateBody(htmlString) {
//alert("updateBody\n" + htmlString);
//return(htmlString);
//console.info("TaskbarUpdateBody");
var oldTaskbarFragment=document.getElementById(taskBarObj.TASKBAR_FRAGMENT_ID);

var trashDivElement=document.getElementById(taskBarObj.TRASH_DIV_ID);
//console.info("trashDivElement==" + trashDivElement);
//console.info(oldTaskbarFragment);
if (trashDivElement==null){
	trashDivElement=document.createElement("div");
	trashDivElement.id=taskBarObj.TRASH_DIV_ID;
	trashDivElement.style.visibiliy="hidden";
	//console.info(trashDivElement);
	try
	{
	document.documentElement.appendChild(trashDivElement);
	}
	catch(e)
	{
	console.error(e);
	}
}	

try
{
var tempDivElement=document.createElement("div");
tempDivElement.innerHTML="";
tempDivElement.innerHTML=htmlString;

////console.info("tempDivElement.innerHTML==" + tempDivElement.innerHTML);
var newTaskbarFragment=taskBarObj.getElementById(tempDivElement,taskBarObj.TASKBAR_FRAGMENT_ID);
//console.info("newTaskbarFragment==" + newTaskbarFragment.nodeName + newTaskbarFragment.id);
if (newTaskbarFragment!=null){
	document.body.replaceChild(newTaskbarFragment,oldTaskbarFragment);
//	trashDivElement.innerHTML="";
	trashDivElement.appendChild(oldTaskbarFragment);
	dojo.dom.destroyNode(oldTaskbarFragment);
}
trashDivElement.appendChild(tempDivElement);
trashDivElement.innerHTML="";

}
catch(ex)
{
console.error("ex==" + ex);
}

}

*/
function TaskbarUpdateBody(htmlString) {
	if( !top.Frameset.UseSM ) {
		alert( "Something tried to use a SM function, even though SM operation is disabled!" );
		return;
	}

	//console.info("TaskbarUpdateBody");
	var oldTaskbarFragment=document.getElementById(taskBarObj.TASKBAR_FRAGMENT_ID);
	if (oldTaskbarFragment!=null) {
		try {	
			var tempDivElement=document.createElement("div");
			tempDivElement.innerHTML="";
			tempDivElement.innerHTML=htmlString;
			var newTaskbarFragment=taskBarObj.getElementById(tempDivElement,taskBarObj.TASKBAR_FRAGMENT_ID);
			//console.info("newTaskbarFragment==" + newTaskbarFragment.nodeName + newTaskbarFragment.id);
			if (newTaskbarFragment!=null){
				document.body.replaceChild(newTaskbarFragment,oldTaskbarFragment);
				dojo._destroyElement(oldTaskbarFragment);
                SMUtils.RunScripts( newTaskbarFragment );
                resizeTaskbar();
				}
			dojo._destroyElement(tempDivElement);	
			ISCTaskbar.Init();
			}
		catch(ex) {
			console.error("ex==" + ex);
			}
		}
	}

taskBarObj.commoncallback = function( data ) {
	// Get the contents of the new body tag
    
	var dsplit = data.split( "<!--BODYSPLIT-->" );
	data = dsplit[1];
	// Find the document's body tag
	var bodytag = document.getElementById( taskBarObj.BODY_TAG_ID );
	// Replace the document's body tag's contents
	bodytag.innerHTML = data;
    ISCTaskbar.Init();
    resizeTaskbar();
};
// End 177818

function ISCTaskbar(){}

// Initialize - should be called whenever the taskbar's contents are updated
ISCTaskbar.Init = function() {
	if( !top.Frameset.UseSM ) {
		//console.info( "SM operation is disabled, will not bind nav pane links and forms." );
		return;
	}

	// Get all links in the document
	var links = document.links;

	// For each link...
	for( var i = 0; i < links.length; i++ ) {
		var href = links[i].href;
		// If this is a taskbar.do link...
		if( href.indexOf( "taskbar.do" ) != -1 ) {
			//console.info("found a taskbar.do link");
			// Bind a call to ISCTaskbarLink.prototype.launch() to the onclick of this link
			dojo.connect( links[i], "onclick", new ISCTaskbarLink( links[i] ), "launch" );
		}
	}
};

function ISCTaskbarLink( link ){
	this.link = link;
}

// Handle a link being clicked
ISCTaskbarLink.prototype.launch = function( evt ) {   
	//console.info(" ISCTaskbarLink.prototype.launch");
	// Halt the event
	evt.preventDefault();
	evt.stopPropagation();
	SMUtils.RequestFragmentCollection( this.link.href );
	};


    function handleTabMouseOver(tab) {
        if (tab.className == "isc-tab-unsel-l") {
            tab.className="isc-tab-over-l";
			while (tab.nextSibling.nodeType != 1) {
				tab=tab.nextSibling;
            }
			tab.nextSibling.className="isc-tab-over-r";
		}
		else if (tab.className == "isc-tab-unsel-r"){
			tab.className="isc-tab-over-r-over";
			while (tab.previousSibling.nodeType != 1) {
				tab=tab.previousSibling;
			}
			tab.previousSibling.className="isc-tab-over-l";
		}
		else if (tab.className == "isc-tab-sel-r"){
			tab.className="isc-tab-sel-r-over";
		}
    }

    function handleTabMouseOverBidi(tab) {
        if (tab.className == "isc-tab-unsel-l-bidi") {
            tab.className="isc-tab-over-l-bidi";
			while (tab.nextSibling.nodeType != 1) {
				tab=tab.nextSibling;
            }
			tab.nextSibling.className="isc-tab-over-r-bidi";
		}
		else if (tab.className == "isc-tab-unsel-r-bidi"){
			tab.className="isc-tab-over-r-over-bidi";
			while (tab.previousSibling.nodeType != 1) {
				tab=tab.previousSibling;
			}
			tab.previousSibling.className="isc-tab-over-l-bidi";
		}
		else if (tab.className == "isc-tab-sel-r-bidi"){
			tab.className="isc-tab-sel-r-over-bidi";
		}
    }


    function handleTabMouseOut(tab){
			if (tab.className == "isc-tab-over-l") {
				tab.className="isc-tab-unsel-l";
				while (tab.nextSibling.nodeType != 1) {
					tab=tab.nextSibling;
				}
				tab.nextSibling.className="isc-tab-unsel-r";
			}
			else if (tab.className == "isc-tab-over-r-over"){
				tab.className="isc-tab-unsel-r";
				while (tab.previousSibling.nodeType != 1) {
					tab=tab.previousSibling;
				}
				tab.previousSibling.className="isc-tab-unsel-l";
			}
			else if (tab.className == "isc-tab-sel-r-over"){
				tab.className="isc-tab-sel-r";
			}
		}

    function handleTabMouseOutBidi(tab){
			if (tab.className == "isc-tab-over-l-bidi") {
				tab.className="isc-tab-unsel-l-bidi";
				while (tab.nextSibling.nodeType != 1) {
					tab=tab.nextSibling;
				}
				tab.nextSibling.className="isc-tab-unsel-r-bidi";
			}
			else if (tab.className == "isc-tab-over-r-over-bidi"){
				tab.className="isc-tab-unsel-r-bidi";
				while (tab.previousSibling.nodeType != 1) {
					tab=tab.previousSibling;
				}
				tab.previousSibling.className="isc-tab-unsel-l-bidi";
			}
			else if (tab.className == "isc-tab-sel-r-over-bidi"){
				tab.className="isc-tab-sel-r-bidi";
			}
		}

    // LI 3693: Support client side portlet interactions 

    function cleanPageResources(pageId){
    	unsubscribeEventBrokerActions(pageId);
    	leaveCustomizeMode(pageId);
    }
    function unsubscribeEventBrokerActions(pageId){
		if(parent.detail && parent.detail.EventBroker){
			parent.detail.EventBroker.unsubscribePortletsInPage(pageId);
		}
    }
    function leaveCustomizeMode(pageId){
    
		if(parent.detail.IscPages && pageId){
			var currentPageDiv = parent.detail.IscPages.getPageElementById( pageId);
			parent.detail.customizer.leaveCustomizeMode(currentPageDiv);
		}
       
    }
    // LI 3693: Support client side portlet interactions end

    function resizeTaskbar(){
        var tbFrame = parent.document.getElementById("iscdetailframeset");
        var tbDiv = document.getElementById("tbdiv").clientHeight;
        var framesetSize = tbFrame.rows;
        var taskbarHeight = framesetSize.substring(0,framesetSize.indexOf(",",0));

        var offsetSize = document.getElementById("PageAction").offsetHeight;
        if (taskbarHeight > 0) { //check for portlet federation
            var rowTemp= framesetSize.substring(framesetSize.indexOf(",",0),framesetSize.length);

            //adjust the taskbar frame so that the div scroll bar will appear
            //  when many tabs are open and not enough screen space
            if (document.getElementById("tbdiv").clientWidth < document.getElementById("tbdiv").scrollWidth) { 
                tbFrame.rows="54"+rowTemp;
                document.getElementById("tbdiv").style.height="52";
            }
            else{
                tbFrame.rows="36"+rowTemp;
                document.getElementById("tbdiv").style.height="36";
            }

            if (offsetSize > 26) {     //used for accessiblity when browser font size is big
                var tbsize = offsetSize+ 30;
                tbFrame.rows= tbsize + rowTemp;
                document.getElementById("tbdiv").style.height=tbsize;
            }
        }
    }
